﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Drawing;
using WindowsFormsApplication1.SNetwork;
using System.Drawing.Drawing2D;
using WindowsFormsApplication1.Events;
using WindowsFormsApplication1.MyMath;
using WindowsFormsApplication1.Graph;
using WindowsFormsApplication1.Main;
using System.Globalization;

namespace WindowsFormsApplication1.Drawing
{


    public class Draw
    {
        static Color[] Colors = new Color[] { 
        Color.Fuchsia,  Color.Aqua,     Color.Yellow,           /*Color.White,*/
        Color.Purple,   Color.Teal,     Color.Olive,            Color.Silver,
        Color.Blue,     Color.Lime,    /* Color.Red,*/              Color.RosyBrown,
        Color.Navy,     Color.Green,    Color.Maroon,           Color.Black, 
        Color.Tomato,   Color.Orange,   Color.DarkGoldenrod,    Color.YellowGreen,
        /*Color.Gray,*/ Color.Crimson,  Color.LightSteelBlue,   Color.BlueViolet
        };
        

        Panel paintPanel;
        private  Bitmap backBuffer;
        public  Bitmap TriangleNet = null;
        Pen coloredPen;
        int x1,y1,x2,y2;

        public int posunX;
        public int posunY;
        bool posun;

        int actualposunX;
        int actualposunY;

        bool drawEdges = true;
        public  bool writeGraph = true;
        bool drawAddConf = true;
        public bool posunGrafu = false;
        public bool HideSN = false;
        public bool drawGraph = true;

        public Draw(Panel panel1)
        {
            paintPanel = panel1;
        }

        public void DrawPalete (){
            Graphics graphics_1;
            graphics_1 = paintPanel.CreateGraphics();

            for (int i=0 ; i<Colors.Length; i++){
                coloredPen = new Pen(Colors[i] ,20);
                x1 = i*20 +30;
                y1 = 700;
                x2 = i*20 +30;
                y2 = 720;
                graphics_1.DrawLine(coloredPen, x1, y1, x2, y2);
            }
            graphics_1.Dispose();
        }

        public void DrawBitmapToPanel()
        {
            Graphics graphics_1;
            graphics_1 = paintPanel.CreateGraphics();
            graphics_1.DrawImage((Image)backBuffer, 0, 0);
            graphics_1.Dispose();
        }

        public void DrawSensorsOfNetwork(SNetwork.SNetwork sn, bool inters, bool posun, int posunX, int posunY, bool arrows)
        {
            this.posun = posun;
            this.actualposunX = posunX;
            this.actualposunY = posunY;
            DrawSensorsOfNetwork(sn, inters, posun, arrows);
        }

        public void DrawSensorsOfNetwork(SNetwork.SNetwork sn, bool inters, bool posunn , bool arrows)
        {
            if (posunn)
            {
                posunX += actualposunX;
                posunY += actualposunY;
                actualposunX = 0;
                actualposunY = 0;

            }
            else
            {
                posunX = 0;
                posunY = 0;
            }

            double m = Parameters.RowHeight * Parameters.scaleFactor;

            makeMesh();

            Graphics graphics_1 = Graphics.FromImage(backBuffer);

            if (!HideSN)
            {
                if (inters)
                {

                    DrawOverlaps(sn, graphics_1, m);
                }

                foreach (Sensor s in sn.Sensors)
                {
                    DrawSensorInGraphics(s, graphics_1, m);
                }

                if (inters)
                {
                    DrawIntersections(sn, graphics_1, m);
                }
            }
            DrawConf(sn, m, graphics_1);
            if (drawAddConf)
             DrawAddConf(sn, m, graphics_1);

            DrawBitmapToPanel();             
            graphics_1.Dispose();
            DrawPalete();
        }

        private void DrawConf(SNetwork.SNetwork sn, double m, Graphics graphics_1)
        {
            Configuration First, Secound;
            List<Configuration> Configurations = MainClass.Configurations;

            if (Configurations != null && Configurations.Count>1)
            {
                for (int i = 0; i < Configurations.Count; i++)
                {
                    First = Configurations.ElementAt(i);
                    Secound = Configurations.ElementAt((i + 1) % Configurations.Count);
                    if (Math.Abs(First.angle - (sn.actualAngle + sn.Period*360 ) ) < 0.5)
                        drawNextEqOfSPs(First, Secound, graphics_1);
                }
            }
        }

        private void DrawAddConf(SNetwork.SNetwork sn, double m, Graphics graphics_1)
        {
            Configuration First, Secound;
            List<Configuration> AdditionalConfigs = MainClass.AdditionalConfigs;
            
            if (AdditionalConfigs != null && AdditionalConfigs.Count > 1)
            {
                int countConf = MainClass.Configurations.Count;
                for (int i = 0; i < AdditionalConfigs.Count; i++)
                {
                    First = AdditionalConfigs.ElementAt(i);
                    Secound = MainClass.Configurations.ElementAt(( (int)(i / 3) + 1) % countConf); // AdditionalConfigs.ElementAt((i + 1) % AdditionalConfigs.Count);
                    if (Math.Abs(First.angle - (sn.actualAngle + sn.Period * 360)) < 0.5)
                        drawNextEqOfSPs(First, Secound, graphics_1);
                }
            }
        }



        private void DrawIntersections(SNetwork.SNetwork sn, Graphics gr, double m)
        {
            foreach (Intersection inters in sn.IntersectionsStatic)
            {
                int xinters = (int)(inters.mp.x * m) - posunX;
                int yinters = (int)(inters.mp.y * m) - posunY;

                coloredPen = new Pen(Color.Black, 3);
                gr.DrawEllipse(coloredPen, xinters - 2, yinters - 2, 4, 4);
            }

            foreach (Intersection inters in sn.IntersectionsDynamic)
            {
                int xinters = (int)(inters.mp.x * m) - posunX;
                int yinters = (int)(inters.mp.y * m) - posunY;

                coloredPen = new Pen(Color.Black, 3);
                gr.DrawEllipse(coloredPen, xinters - 2, yinters - 2, 4, 4);
            }
        }


        private void DrawOverlaps(SNetwork.SNetwork sn, Graphics gr, double m)
        {
            gr.SmoothingMode = SmoothingMode.AntiAlias;
            coloredPen = new Pen(Color.Black, 8);
            foreach (Overlap ovl in sn.getActualOverlaps())
            {
                x1 = (int)(ovl.ls.b.x * m) - posunX;
                y1 = (int)(ovl.ls.b.y * m) - posunY;
                x2 = (int)(ovl.ls.e.x * m) - posunX;
                y2 = (int)(ovl.ls.e.y * m) - posunY;

                gr.DrawLine(coloredPen, x1, y1, x2, y2);
            }
        }

        public void DrawSensor(Sensor s)
        {
            double m = Parameters.RowHeight * Parameters.scaleFactor;
            Graphics  graphics_1 = paintPanel.CreateGraphics();
            DrawSensorInGraphics(s, graphics_1, m);
            graphics_1.Dispose();
        }

        public void DrawPoint(MyPoint p)
        {
            double m = Parameters.RowHeight * Parameters.scaleFactor;
            x1 = (int)(p.x * m) ;
            y1 = (int)(p.y * m);
            Graphics graphics_1 = paintPanel.CreateGraphics();
            graphics_1.SmoothingMode = SmoothingMode.AntiAlias;
            coloredPen = new Pen(Color.Black, 3);
            graphics_1.DrawEllipse(coloredPen, x1 - 2, y1 - 2, 4, 4);
            graphics_1.Dispose();
        }

        public void DrawMyLS(MyLineSegment ls)
        {
            double m = Parameters.RowHeight * Parameters.scaleFactor;
            Graphics graphics_1 = paintPanel.CreateGraphics();
            graphics_1.SmoothingMode = SmoothingMode.AntiAlias;
           
            x1 = (int)(ls.b.x * m);
            y1 = (int)(ls.b.y * m);
            x2 = (int)(ls.e.x * m);
            y2 = (int)(ls.e.y * m);
 
            coloredPen = new Pen(Color.Black, 4);
            graphics_1.DrawLine(coloredPen, x1, y1, x2, y2);
            graphics_1.Dispose();
        }

        public void DrawGraph(Graph<SPoint> graph)
        {
            Graphics gr = paintPanel.CreateGraphics();
            DrawGraph(graph, gr);
            gr.Dispose();
        }

        private void DrawSensorInGraphics(Sensor s, Graphics graphics_1, double m)
        {
            graphics_1.SmoothingMode = SmoothingMode.AntiAlias;
            Point b = s.b.ToPoint(posunX, posunY);
            Point e = s.e.ToPoint(posunX, posunY);

            if (s is BSensor)
            {
                coloredPen = new Pen(Color.Blue, 3);
                graphics_1.DrawLine(coloredPen, b.X, b.Y, e.X, e.Y);
            }

            if (s is RSensor)
            {
                coloredPen = new Pen(Color.Red, 3);
                graphics_1.DrawLine(coloredPen, b.X, b.Y, e.X, e.Y);

                coloredPen = new Pen(Color.Green, 3);
                graphics_1.DrawEllipse(coloredPen, b.X - 2, b.Y - 2, 4, 4);

                coloredPen = new Pen(Color.Yellow, 3);
                graphics_1.DrawEllipse(coloredPen, e.X - 2, e.Y - 2, 4, 4);
            }
        }

        public void makeMesh()
        {
            if (backBuffer == null)
             backBuffer = new Bitmap(this.paintPanel.ClientSize.Width, this.paintPanel.ClientSize.Height);
            Graphics graphics_1 = Graphics.FromImage(backBuffer);

            if (TriangleNet == null || Parameters.RowHeightChanged)
            {                
                int pw = paintPanel.Size.Width;
                int ph = paintPanel.Size.Height;
                graphics_1.Clear(Color.FromArgb(240, 240, 240));
                TriangleNet = new Bitmap(pw, ph);
                Graphics g1 = Graphics.FromImage(TriangleNet);
                g1.SmoothingMode = SmoothingMode.AntiAlias;
                drawTraingleNetInGraphic(g1, pw, ph);
                graphics_1.DrawImage((Image)TriangleNet, 0, 0);
            }
            else
            {
                graphics_1.Clear(Color.FromArgb(240, 240, 240));
                graphics_1.DrawImage((Image)TriangleNet, 0, 0);
            }
            graphics_1.Dispose();
        }


        private void drawTraingleNetInGraphic(Graphics gr, int pw, int ph)
        {
            Pen coloredPen = new Pen(Color.Gray, 1);
            int rowH = Parameters.RowHeight;
            double myconst = Parameters.myconst;
            double rowW = rowH * myconst; 

            int y = 0;
            bool shift = false;

            //kym sa nedostaneme na spodok
            while (y <= ph )
            {
                // kazdy druhy riadok sa posunie o pol trojuholnika, aby sa vytvorila siet spravne
                shift = !shift;
                double posun = (shift) ? -1 : -2;
                int i = 0;

                gr.DrawString((y/rowH).ToString(), new Font("Arial", 7), Brushes.Gray, new PointF(0, y +2));

                while ((rowW*i) <= (pw -  rowW))
                {
                    if (y<=rowH-2)
                        gr.DrawString((i-1).ToString(), new Font("Arial", 7), Brushes.Gray, new PointF((int)((i + posun ) * rowW -6), y + 2));
                    i++;
                    if (y <= rowH-2)
                        gr.DrawString((i - 1).ToString(), new Font("Arial", 7), Brushes.Gray, new PointF((int)((i + posun) * rowW - 6), y + 2));
                    gr.DrawLine(coloredPen, (int)((i + posun) * rowW), y, (int)((i + posun +1) * rowW), y + rowH);
                    gr.DrawLine(coloredPen, (int)((i + posun) * rowW), y, (int)((i + posun -1) * rowW), y + rowH);
                    gr.DrawLine(coloredPen, (int)((i + posun + 1) * rowW), y + rowH, (int)((i + posun - 1) * rowW), y + rowH);
                    i++;
                }

                if (shift && y > rowH) gr.DrawLine(coloredPen, (int)((i + posun-1) * rowW), y, (int)((i + posun ) * rowW), y - rowH);
                y += rowH;
            }
        }

        internal void drawNextEqOfSPs(Configuration conf,Configuration nextconf, Graphics gr )
        {
            double nextConfAngle = nextconf.angle ;

            //ak mame specialne oblasti, tak tie vykreslujeme, inak vykreslujeme povodne
            if (conf.SpecialSAreas != null)
            {
                foreach (SimpleArea SArea in conf.SpecialSAreas)
                {
                    drawSimpleArea(SArea, gr);
                }
            }
            else
            {
                if (conf.SAreas != null)
                    foreach (SimpleArea SArea in conf.SAreas)
                    {
                        drawSimpleArea(SArea, gr);
                    }
            }

            if (!HideSN)
                foreach (SPoint sp in conf.SPs)
                {
                    double m = Parameters.RowHeight * Parameters.scaleFactor;

                    gr.SmoothingMode = SmoothingMode.AntiAlias;

                    coloredPen = new Pen(Color.Magenta, 4);
                    coloredPen.DashStyle = DashStyle.Dot;
                    coloredPen.EndCap = System.Drawing.Drawing2D.LineCap.ArrowAnchor/*Triangle*/;

                    foreach (SPoint eqSP in sp.getEqSPsWithAngle(nextConfAngle))
                    {
                        if (!sp.Location.Equals(eqSP.Location))
                        {
                            x1 = (int)(sp.Location.x * m) - posunX;
                            y1 = (int)(sp.Location.y * m) - posunY;
                            x2 = (int)(eqSP.Location.x * m) - posunX;
                            y2 = (int)(eqSP.Location.y * m) - posunY;
                            gr.DrawLine(coloredPen, x1, y1, x2, y2);
                        }
                    }
                }


                if (conf.SpecialGraph != null)
                {
                    this.DrawGraph(conf.SpecialGraph, gr);
                }
                else
                {
                    this.DrawGraph(conf.InductedGraph, gr);
                }
            

            if (writeGraph)
            {
                if (conf.SpecialGraph != null)
                {
                    Program.cloud.WriteToLog(conf.SpecialGraph.ToString());
                    Program.cloud.WriteToLog(conf.SpecialSAreasToString());
                }
                else
                {
                    Program.cloud.WriteToLog(conf.InductedGraph.ToString());
                    Program.cloud.WriteToLog(conf.SAreasToString());
                }
            }
        }

        private void DrawGraph(Graph<SPoint> graph, Graphics graphics_1)
        {
            graphics_1.SmoothingMode = SmoothingMode.AntiAlias;

            double m = Parameters.RowHeight * Parameters.scaleFactor;
            int xn;
            int yn;
            int GposunX=0;
            int GposunY=0;

            if (posunGrafu)
            {
                GposunX = -posunX;
                GposunY = -posunY;
            }
            foreach (Vertex<SPoint> v in graph.Vertices)
            {
                

                x1 = (int)(v.Data.Location.x * m) + GposunX;
                y1 = (int)(v.Data.Location.y * m) + GposunY;

                if (v.Data.AddedAsEventLocation)
                    graphics_1.DrawString(v.Index.ToString(), new Font("Tahoma", 15), Brushes.Red, new PointF(x1, y1));
                else
                    graphics_1.DrawString(v.Index.ToString(), new Font("Tahoma", 15), Brushes.Black, new PointF(x1, y1));


                int a = Color.Green.A;
                int r = Color.Green.R;
                int g = Color.Green.G;
                int b = Color.Green.B;

                Color cl= Color.FromArgb(200, r, g , b);
                cl = Color.Green;
                if (drawEdges)
                {
                    foreach (Vertex<SPoint> e in graph.neighbours(v))
                    {
                        coloredPen = new Pen(cl, 1);
                        xn = (int)(e.Data.Location.x * m) + GposunX;
                        yn = (int)(e.Data.Location.y * m) + GposunY;
                        graphics_1.DrawLine(coloredPen, x1, y1, xn, yn);
                        coloredPen = new Pen(Color.Black, 3);
                    }

                    foreach (Vertex<SPoint> e in graph.extraNeighbours(v))
                    {
                        coloredPen = new Pen(Color.Brown, 1);
                        xn = (int)(e.Data.Location.x * m) + GposunX;
                        yn = (int)(e.Data.Location.y * m) + GposunY;
                        graphics_1.DrawLine(coloredPen, x1, y1, xn, yn);
                        coloredPen = new Pen(Color.Black, 3);
                    }

                }
                coloredPen = new Pen(Color.Black, 3);
            }
        }

        private void drawSimpleArea(SimpleArea SArea, Graphics gr)
        {
            SolidBrush brushOne = new SolidBrush(Color.Blue);
            Point[] polygonPoints = new Point[SArea.Polygon.Count];
            int j = 0;
            int GposunX = 0;
            int GposunY = 0;
            if (posunGrafu)
            {
                GposunX = posunX;
                GposunY = posunY;
            }
            foreach (SPoint sp in SArea.Polygon)
            {
                int f = (int)sp.Location.x;
                polygonPoints[j] = sp.Location.ToPoint(GposunX, GposunY);
                j++;
            }
            Color color = Colors[SArea.actualIndex % Colors.Length];
            int a = color.A;
            int r = color.R;
            int g = color.G;
            int b = color.B;

            brushOne.Color = color;
            if (SArea.clear )
            {
                brushOne.Color = Color.White;
            }

            if (!SArea.inner)
            {
                brushOne.Color = Color.FromArgb(0, r, g, b);
            }

            if (polygonPoints.Length>2)
                gr.FillPolygon(brushOne, polygonPoints);

        }

        
    }
}
