﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using WindowsFormsApplication1.MyMath;
using WindowsFormsApplication1.SNetwork;

namespace WindowsFormsApplication1.Events
{
    public class Intersection : WithActers
    {
        public MyPoint mp;
         public List<PairOfActers> ActersPairs = new List<PairOfActers>(10);


        public void addActersPair(PairOfActers s)
        {
            if (!ActersPairs.Contains(s))
                ActersPairs.Add(s);
        }
        public Intersection(double x, double y)
        {
            this.mp = new MyPoint(x, y);
        }

        public Intersection(MyPoint mp)
        {
            this.mp = mp;
        }

        public Intersection(MyPoint mp, List<Sensor> acters)
        {
            this.mp = mp;
            this.Acters = acters;
        }


        public static Intersection GetIntersection(Intersection inters)
        {
            return new Intersection(inters.mp, inters.Acters.ToList());
        }

        public override bool Equals(Object obj)
        {
            if (!(obj is Intersection)) return false;
            Intersection s = (Intersection)obj;
            if (this.mp == null || s.mp == null)
                return false;
            if (this.mp.Equals(s.mp))
                return true;
            return false;
        }

        public override int GetHashCode()
        {
            return base.GetHashCode();
        }

        public static List<Intersection> GetListsTogether(List<Intersection> ls1, List<Intersection> ls2)
        {
            List<Intersection> result = new List<Intersection>(ls1.Count + ls2.Count );
            foreach (Intersection inters in ls1)
            {
                processInters(GetIntersection(inters) ,result);
            }
            foreach (Intersection inters in ls2)
            {
                processInters(GetIntersection(inters), result);
            }
            return result;
        }

        private static void processInters(Intersection inters, List<Intersection> list)
        {
            if (list.Contains(inters)) //ak uz je prienik ulozeny
            {
                foreach (Sensor s in inters.Acters) // pridame novych akterov
                {
                    list.ElementAt(list.IndexOf(inters)).addActer(s);
                }
            }
            else //ak tento prienik este nemame
            {
                list.Add(inters); // prienik pridame
            }
        }


        internal void addActersPairs(List<PairOfActers> list)
        {
            foreach (PairOfActers pair in list)
            {
                addActersPair(pair);
            }
        }
    }
}
