﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using WindowsFormsApplication1.MyMath;
using WindowsFormsApplication1.SNetwork;

namespace WindowsFormsApplication1.Events
{
    public class Overlap : WithActers
    {
        public MyLineSegment ls;
        public double angle;

        public Overlap(MyPoint b, MyPoint e, double angle)
        {
            ls = new MyLineSegment(b, e);
            this.angle = angle;
        }

        public Overlap(MyPoint b, MyPoint e, double angle, Sensor acter1, Sensor acter2)
        {
            ls = new MyLineSegment(b, e);
            this.angle = angle;
            addActers(acter1, acter2);
        }

        public override String ToString()
        {
            String s;
            s = "Ovl: " + ls.ToString() + " angle: " + Math.Round(angle, 3)+ "\r\n  acters:";
            foreach (Sensor ss in Acters)
            {
                s = s + ss.id.ToString() + "; ";
            }

            return s;
        }

        public override bool Equals(Object obj)
        {
            if (!(obj is Overlap)) return false;
            Overlap s = (Overlap)obj;
            if (this.ls.Equals(s.ls) && Math.Abs(this.angle - s.angle)<Parameters.angleDeviation )
                return true;
            return false;
        }

        public Overlap(MyLineSegment ls)
        {
            this.ls =  new MyLineSegment(ls);
        }

        public Overlap(MyLineSegment ls, double angle)
        {
            this.ls = ls;
            this.angle = angle;
        }

        public override int GetHashCode()
        {
            return base.GetHashCode();
        }
    }
}
