﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using WindowsFormsApplication1.MyMath;
using WindowsFormsApplication1.SNetwork;

namespace WindowsFormsApplication1.FormActions
{
    class Editing
    {
        static MyPoint p1 = null;
        static MyPoint p2 = null;

        private static bool ProcessChosingPoints(int r, int s)
        {
            int scale = Parameters.scaleFactor;

            if (p1 == null)
            {
                Program.myForm.clearText();
                Program.myForm.writeText("prvy bod (stlpec,riadok):" + "(" + (double)s + ", " + (double)r + ")");
                p1 = new MyPoint((double)s / (double)scale, (double)r / (double)scale);
                return false;
            }
            else
            {
                Program.myForm.writeText("druhy bod (stlpec,riadok):" + "(" + (double)s + ", " + (double)r + ")");
                p2 = new MyPoint((double)s / (double)scale, (double)r / (double)scale);
                if (p1.Equals(p2))
                {
                    Program.myForm.writeText("!!!vybarali ste rovnake body : AKCIA NEUSPESNA ");
                    
                    p1 = null;
                    p2 = null;
                    return false;
                }
                else
                {
                    return true;
                }
            }
        }

        internal static void ProcessClick(int x, int y)
        {
            int vyska = Parameters.RowHeight;
            double myconst = Parameters.myconst;
            double sirka = vyska * myconst;
            //vypocitame na ktory riadok a stlpec sme klikli
            int r = (int)Math.Round((double)y / vyska, 0);
            int s = (int)Math.Round((double)x / sirka, 0); 
            bool chosed = ProcessChosingPoints(r, s);

            if (chosed)
            {
                if (Program.myForm.radioAdd.Checked == true)
                {
                    AddSensor();
                }
                else
                {
                    DellSensor();
                }
                SNetwork.SNetwork sn = Program.cloud.sn;

                p1 = null;
                p2 = null;
            }
        }
        private static void DellSensor()
        {
            
            SNetwork.SNetwork sn = Program.cloud.sn;
            if (sn.deleteSensorWithActualPosition(p1, p2))
            {
                sn.resetActualNetwork();
                Program.myForm.writeText("!!! AKCIA USPESNA : senzor vymazany");
                Program.cloud.draw.DrawSensorsOfNetwork(Program.cloud.sn, true, false,true);
            }
            else
            {
                Program.myForm.writeText("!!! AKCIA NEUSPESNA : ziadny senzor sa nezhodoval");
            }
        }

        private  static void AddSensor()
        {
            SNetwork.SNetwork sn = Program.cloud.sn;
            Sensor sensor = new Sensor();
            if (Program.myForm.radioBS.Checked == true)
                sensor = new BSensor(new MyPoint(p1), new MyPoint(p2));
            if (Program.myForm.radioRSCCW.Checked == true)
                sensor = new RSensor(new MyPoint(p1), new MyPoint(p2), true);
            if (Program.myForm.radioRSCW.Checked == true)
                sensor = new RSensor(new MyPoint(p1), new MyPoint(p2), false);
            sn.AddSensor(sensor);
            sn.resetActualNetwork();
            
            Program.myForm.writeText("!!! AKCIA USPESNA : pridany senzor " + sensor.ToString());
            Program.cloud.drawSN(0);
        }
    }
}
