﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using WindowsFormsApplication1.MyMath;
using WindowsFormsApplication1.SNetwork;
using WindowsFormsApplication1.Events;

namespace WindowsFormsApplication1.FormActions
{
    class TestClass
    {
        public static void testEventsSearch()
        {
            List<Event> events = EventSearch.getEvents(Program.cloud.sn, Parameters.angleOfPseudoStep,Parameters.iterations);

            Program.cloud.WriteToLog(events.Count.ToString());

            foreach (Event e in events)
            {
                Program.cloud.WriteToLog(e.ToString());
            }
        }

        public static void testAngleToReachPoint()
        {
            MyPoint mp1 = new MyPoint(1, 1);
            MyPoint mp2 = new MyPoint(4, 1);
            MyPoint mp3 = new MyPoint(2, 2);

            RSensor rs1 = new RSensor(mp1, mp2, false);

            double angle = Angles.AngleToReachPoint(rs1, mp3);
            Program.cloud.draw.DrawSensor(rs1);
            Program.cloud.draw.DrawPoint(mp3);

            rs1.RotateSensor(angle);
            Program.cloud.draw.DrawSensor(rs1);
        }

        public static void EndMeetTest()
        {
            MyPoint mp1 = new MyPoint(0, 1);
            MyPoint mp2 = new MyPoint(1,2);
            MyPoint mp3 = new MyPoint(4, 1);
            MyPoint mp4 = new MyPoint(3, 2);

            RSensor rs1 = new RSensor(mp1, mp2, false);
            RSensor rs2 = new RSensor(mp3, mp4, true);


        }


        public static void test()
        {
            MyPoint mp1 = new MyPoint(1, 1);
            MyPoint mp2 = new MyPoint(4, 1);
            MyPoint mp3 = new MyPoint(2, 0);
            MyPoint mp4 = new MyPoint(3, 2);

            RSensor rs1 = new RSensor(mp1, mp3, false);
            RSensor rs2 = new RSensor(mp2, mp4, false);

            MyPoint mp5 = new MyPoint(2, 2);
            MyPoint mp6 = new MyPoint(3, 2);
            MyPoint mp7 = new MyPoint(2, 2);
            MyPoint mp8 = new MyPoint(3, 3);

            RSensor rs = new RSensor(mp5, mp6, true);
            BSensor bs = new BSensor(mp7, mp8);

            Overlap o = OverlapMath.getOverlap(rs1, rs2)[0];


            Program.cloud.draw.DrawSensor(rs1);
            Program.cloud.draw.DrawSensor(rs2);




            rs1.RotateSensor(o.angle);
            rs2.RotateSensor(o.angle);

            if (o != null)
            {
                Program.cloud.draw.DrawMyLS(o.ls);
                rs.RotateSensor(o.angle);

            }
            Program.cloud.draw.DrawSensor(rs1);
            Program.cloud.draw.DrawSensor(rs2);
        }



        public static void TestEvent()
        {
            SNetwork.SNetwork sn = Program.cloud.sn;
            sn.findIntersections();
            sn.findOverlaps();
            Step first = Step.makeStep(sn.actualAngle);
            
            sn.rotateNetworkAndSearchInters(sn.actualAngle + 20);
            sn.findIntersections();

            Step secound = Step.makeStep(sn.actualAngle);
             List<Event> events = first.getEvents(secound);

             foreach (Event e in events)
             {
                 Program.cloud.WriteToLog(e.ToString());
             }
        }




        internal static void OverTest()
        {
            MyPoint mp1 = new MyPoint(1, 2);
            MyPoint mp2 = new MyPoint(2, 3);

            MyPoint mp3 = new MyPoint(4, 2);
            MyPoint mp4 = new MyPoint(3, 3);

            RSensor rs1 = new RSensor(mp1, mp2, false);
            RSensor rs2 = new RSensor(mp3, mp4, true);

        
            Program.cloud.draw.DrawSensor(rs1);
            Program.cloud.draw.DrawSensor(rs2);

            Overlap o = OverlapMath.getOverlap(rs1, rs2)[0];

            if (o != null)
            {
                rs1.RotateSensor(o.angle);
                rs2.RotateSensor(o.angle);
                Program.cloud.draw.DrawMyLS(o.ls);

            }
        }

        internal static void OverTest3()
        {
            MyPoint mp1 = new MyPoint(1, 2);
            MyPoint mp2 = new MyPoint(2, 3);

            MyPoint mp3 = new MyPoint(4, 2);
            MyPoint mp4 = new MyPoint(3, 3);

            RSensor rs1 = new RSensor(mp1, mp2, false);
            RSensor rs2 = new RSensor(mp3, mp4, true);

            
            Program.cloud.draw.DrawSensor(rs1);
            Program.cloud.draw.DrawSensor(rs2);

            Overlap o = OverlapMath.getOverlap(rs1, rs2)[0];

            if (o != null)
            {
                rs1.RotateSensor(o.angle);
                rs2.RotateSensor(o.angle);
                Program.cloud.draw.DrawMyLS(o.ls);

            }
        }

        internal static void OverTest2()
        {
            MyPoint mp1 = new MyPoint(1, 1);
            MyPoint mp2 = new MyPoint(1, 2);
            MyPoint mp3 = new MyPoint(1, 0);

            RSensor rs1 = new RSensor(mp1, mp2, false);
            RSensor rs2 = new RSensor(mp1, mp3, true);
            Overlap o = OverlapMath.getOverlap(rs1, rs2)[0];
            Program.cloud.draw.DrawSensor(rs1);
            Program.cloud.draw.DrawSensor(rs2);
              if (o != null)
               {
                   rs1.RotateSensorFromInitial(o.angle);
                   rs2.RotateSensorFromInitial(o.angle);
                   
               Program.cloud.draw.DrawMyLS(o.ls);

               }

               o = OverlapMath.getOverlap(rs1, rs2)[1];

               if (o != null)
               {
                   rs1.RotateSensorFromInitial(o.angle);
                   rs2.RotateSensorFromInitial(o.angle);
                  
                   Program.cloud.draw.DrawMyLS(o.ls);
               }
        }


    }
}
