﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using WindowsFormsApplication1.XMLwork;
using WindowsFormsApplication1.FormActions;
using WindowsFormsApplication1.SNetwork;
using WindowsFormsApplication1.MyMath;
using WindowsFormsApplication1.Events;
using WindowsFormsApplication1.Main;
using System.Threading;

namespace WindowsFormsApplication1
{
    public partial class Form1 : Form
    {
        bool CanWrite = true;
        bool PlayActive = false;
        bool _shouldStop = false;
        Thread thread = null;
        int stepcounter = 0;

        public Form1()
        {
            InitializeComponent();
            this.SetStyle(ControlStyles.OptimizedDoubleBuffer, true);    
        }


        private void setEnebledButtons(int b1, int b2, int b3, int b4, int b5, int c1, int b7, int b8, int b9)
        {
            button1.Enabled = b1 == 1;
            button3.Enabled = b2 == 1;
            button4.Enabled = b3 == 1;
            button5.Enabled = b4 == 1;
            button2.Enabled = b5 == 1;
            button7.Enabled = b7 == 1;
            ButtMailAlg.Enabled = b8 == 1;
            comboBox1.Enabled = c1 == 1;
            VypisButton.Enabled = b9 == 1;
            
        }

        private void button1_Click(object sender, EventArgs e)
        {
            //System.Console.WriteLine("PLAY");
            PlayActive = true;
            //tabPage2. = false;
            tabControl1.TabPages.Remove(tabPage2);
            tabControl1.TabPages.Remove(tabPage3);
            
            setEnebledButtons(0, 1, 0, 0, 1, 0,0,0,0);
            _shouldStop = false;
            CanWrite = false;
            thread = new Thread(new ThreadStart(WorkThreadFunction));
            thread.Start();
        }

        private void button3_Click(object sender, EventArgs e)
        {
            System.Console.WriteLine("PAUSE");
            setEnebledButtons(1, 0, 1, 1, 1, 1,1,1,1);
            RequestStop();
            if (!tabControl1.TabPages.Contains(tabPage2))
                tabControl1.TabPages.Add(tabPage2);
            if (!tabControl1.TabPages.Contains(tabPage3))
                tabControl1.TabPages.Add(tabPage3);
            CanWrite = true;
            tabControl1.Enabled = true;
            PlayActive = false;
            if (stepcounter >= 0 && (stepcounter < comboBox1.Items.Count))
                comboBox1.SelectedIndex = stepcounter;
        }

        private void button2_Click(object sender, EventArgs e)
        {
            System.Console.WriteLine("STOP");
            if (!tabControl1.TabPages.Contains(tabPage2))
            tabControl1.TabPages.Add(tabPage2);
            if (!tabControl1.TabPages.Contains(tabPage3))
            tabControl1.TabPages.Add(tabPage3);
            setEnebledButtons(1, 0, 0, 0, 0, 1,1,1,1);
            RequestStop();
            stepcounter = 0;
            CanWrite = true;
            PlayActive = false;
            tabControl1.Enabled = true;

            Program.cloud.sn.rotateNetworkAndSearchInters(0);
            Program.cloud.draw.DrawSensorsOfNetwork(Program.cloud.sn, true, checkBox1.Checked, true);
            if (stepcounter >= 0 && (stepcounter < comboBox1.Items.Count))
                comboBox1.SelectedIndex = stepcounter;
        }


        private void makeStepWithSN()
        {
            stepcounter++;

            Program.cloud.sn.rotateNetworkAndSearchInters(stepcounter * Parameters.stepangle);
            Program.cloud.draw.DrawSensorsOfNetwork(Program.cloud.sn, true, checkBox1.Checked, true);

        }

        public void WorkThreadFunction()
        {
            try
            {
                Console.Out.WriteLine("Hello World!");
                int angle = 10;
                while (!_shouldStop)
                {
                    angle = (angle + 10) % 360;
                    makeStepWithSN();
                }
            }
            catch (Exception ex)
            {
                Console.WriteLine(ex.ToString());
                Console.WriteLine("tred skoncil");
                Console.WriteLine(ex.ToString());
            }
        }

        private void sietToolStripMenuItem_Click(object sender, EventArgs e)
        {

        }

        private void načítaťZoSúboruToolStripMenuItem_Click(object sender, EventArgs e)
        {
            FormAction.OpenDialogForReadSNetwork(uložiťSietToolStripMenuItem);
        }


        public void writeText(String s)
        {
            if (CanWrite)
            {
                richTextBox1.AppendText(" " + s + "\r\n");
                richTextBox1.SelectionStart = richTextBox1.Text.Length;
                richTextBox1.Refresh();
                richTextBox1.ScrollToCaret();
            }
        }

        public void removeLastRow()
        {
            FormAction.removeLastRow(this.richTextBox1);
        }

        private void button7_Click(object sender, EventArgs e)
        {
            if (!PlayActive)
            {
                writeText("::AKCIA:: vykreslenie: zacalo");
                Program.cloud.draw.DrawSensorsOfNetwork(Program.cloud.sn, true, false, true);
                Program.cloud.draw.DrawPalete();
                writeText("::KONIEC::vykreslenie: hotovo");
            }
        }

        private void button6_Click(object sender, EventArgs e)
        {
            writeText("::AKCIA:: hladanie konfig: zacalo");
           // Program.cloud.sn.findOverlaps();             
         //   Program.cloud.sn.findIntersections();
          //  FormAction.drawSN();
            List<Event> allEvents = EventSearch.getEvents(Program.cloud.sn, 5, 2);
            List<Configuration> confs = ConfigurationsCreate.configurationsCreate(allEvents);

           Program.cloud.sn.resetActualNetwork();
           Program.cloud.draw.DrawSensorsOfNetwork(Program.cloud.sn,true,false,true);
           Program.cloud.draw.DrawGraph(confs.First().InductedGraph);

            writeText("::KONIEC:: hladanie konfig: hotovo");
        }

        private void button8_Click(object sender, EventArgs e)
        {
            if (!PlayActive)
            {
                clearText();
                writeText("::AKCIA:: test: zacal");
                //TestClass.EndMeetTest();
                // TestClass.OverTest();
                //   TestClass.TestEvent();
                TestClass.testEventsSearch();
                writeText("::KONIEC:: test: hotovo");
            }
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            Program.cloud.draw.makeMesh();


            uložiťSietToolStripMenuItem.Available = false;

            radioAdd.Checked = true;
            radioRSCW.Checked = true;
            //Checked = true;

            groupBox1.Hide();
            groupBox2.Hide();
            groupBox3.Hide();
            DellAllButton.Hide();

            setOptionsFromParameters();

        }

        private void hScrollBar1_Scroll(object sender, ScrollEventArgs e)
        {
            label1.Text = e.NewValue.ToString();
        }

        private void hScrollBar2_Scroll(object sender, ScrollEventArgs e)
        {
            label2.Text = e.NewValue.ToString();
        }

        public void setOptionsFromParameters(){
            label2.Text = Parameters.RowHeight.ToString();
            label1.Text = Parameters.scaleFactor.ToString();
            AngleValueL.Text = Parameters.stepangle.ToString();
            hScrollBar1.Value = Parameters.scaleFactor;
            hScrollBar2.Value = Parameters.RowHeight;
            hScrollBar3.Value = (int)Parameters.stepangle;

            textBoxEpsB.Text = Parameters.pointDeviation.ToString();
            textBoxEpsUh.Text = Parameters.angleDeviation.ToString();
            textBoxEpsConf.Text = Parameters.angleEpsilonInConf.ToString();

            textBoxIter.Text = Parameters.iterations.ToString();
            textBoxPseudStep.Text = Parameters.angleOfPseudoStep.ToString();
            textBoxRound.Text = Parameters.countOfRot.ToString();
            
            for (int i = 0; i < 360*Parameters.countOfRot; i = i + (int)Parameters.stepangle)
            {
                comboBox1.Items.Add(i);
            }
            comboBox1.SelectedIndex = 0;

        }

        private void button9_Click(object sender, EventArgs e)
        {
            Parameters.scaleFactor = hScrollBar1.Value;

            if (Parameters.RowHeight != hScrollBar2.Value)
                Parameters.RowHeightChanged = true;

            Parameters.RowHeight = hScrollBar2.Value;
            
            
            Program.cloud.draw.DrawSensorsOfNetwork(Program.cloud.sn, true,false,true);

            Parameters.stepangle = hScrollBar3.Value;
            comboBox1.Items.Clear();
            for (int i = 0; i < 360 * Parameters.countOfRot; i = i + (int)Parameters.stepangle)
            {
                comboBox1.Items.Add(i);
            }
            Program.cloud.WriteToLog("HODNOTY ZMENENE");
        }

        private void hScrollBar3_Scroll(object sender, ScrollEventArgs e)
        {
            AngleValueL.Text = e.NewValue.ToString();
        }

        private void comboBox1_SelectedIndexChanged(object sender, EventArgs e)
        {
            int x = (int)comboBox1.SelectedItem;
            Program.cloud.sn.rotateNetworkAndSearchInters(x);
            Program.cloud.draw.DrawSensorsOfNetwork(Program.cloud.sn, true,checkBox1.Checked,true);
            stepcounter = comboBox1.SelectedIndex;
        }

        int StartSlideX, StartSlideY;
        int EndSlideX, EndSlideY;
        int posunX=0;
        int posunY = 0;

        private void panel1_MouseDown(object sender, MouseEventArgs e)
        {

            StartSlideX = e.X;
            StartSlideY = e.Y;
        }

        private void panel1_MouseUp(object sender, MouseEventArgs e)
        {
            if (!PlayActive)
            {
                if (checkBox1.Checked)
                {
                    EndSlideX = e.X;
                    EndSlideY = e.Y;
                    posunX = StartSlideX - EndSlideX;
                    posunY = StartSlideY - EndSlideY;
                    Program.cloud.draw.DrawSensorsOfNetwork(Program.cloud.sn, true, checkBox1.Checked, posunX, posunY, true);
                }
                else
                {
                    posunY = 0;
                    posunX = 0;
                }
            }
        }

        private void checkBox1_CheckedChanged(object sender, EventArgs e)
        {
            posunY = 0;
            posunX = 0;
            if (!checkBox1.Checked)
            {
                Program.cloud.draw.DrawSensorsOfNetwork(Program.cloud.sn, true, checkBox1.Checked,true);
            }
        }

       public  System.Windows.Forms.ToolTip ToolTip1 = new System.Windows.Forms.ToolTip();

        private void panel1_MouseMove(object sender, MouseEventArgs e)
        {
            if (!PlayActive)
            {
                double m = Parameters.RowHeight * Parameters.scaleFactor;
                double x = e.X;
                double y = e.Y;
                if (checkBox1.Checked)
                {
                    x += Program.cloud.draw.posunX;
                    y += Program.cloud.draw.posunY;
                }
                double MyY = y / m;
                double MyX = x / m;

                if (Program.cloud.sn.Sensors.Count > 0)

                    foreach (Sensor s in Program.cloud.sn.Sensors)
                    {
                        if (Distances.distancePointLineSegment(s.b, s.e, new MyPoint(MyX, MyY)) < 0.1)
                        {
                            ToolTip1.Show(s.id.ToString(), this, new Point(e.X, e.Y), 400);
                        }
                    }
            }
        }

        private void VypisButton_Click(object sender, EventArgs e)
        {
            if (!PlayActive)
            {
                clearText();
                writeText(Program.cloud.sn.ToString());
            }
        }

        public void clearText()
        {
            richTextBox1.Clear();
        }

        private void panel1_MouseClick(object sender, MouseEventArgs e)
        {
            int x = e.X;
            int y = e.Y;
            if (checkBoxEdit.Checked)
            {
                Editing.ProcessClick(x, y);
            }
        }

        private void uložiťSietToolStripMenuItem_Click(object sender, EventArgs e)
        {
            XMLWrite.saveNetoworkInFile(Program.cloud.sn);
        }

        private void DellAllButton_Click(object sender, EventArgs e)
        {
            if (checkBoxEdit.Checked)
            {
                DialogResult d = MessageBox.Show("Naozaj chcete zmazat celu siet?", "Potvrd zmazanie", MessageBoxButtons.YesNo, MessageBoxIcon.Question);

                if (d == DialogResult.Yes)
                {
                    Program.cloud.sn.clearNetwork();
                }
                FormAction.drawSN();
            }
        }

        private void checkBoxEdit_CheckedChanged(object sender, EventArgs e)
        {
            if (!checkBoxEdit.Checked)
            {
                groupBox1.Hide();
                groupBox2.Hide();
                groupBox3.Hide();
                DellAllButton.Hide();
            }

            if (checkBoxEdit.Checked)
            {
                groupBox1.Show();
                groupBox2.Show();
                groupBox3.Show();
                DellAllButton.Show();
            }
        }

        private void uložiťSieťAkoToolStripMenuItem_Click(object sender, EventArgs e)
        {
            FormAction.SaveDialogForSaveSNetwork();
        }

        private void ButtMailAlg_Click(object sender, EventArgs e)
        {

             MainClass.mainAlg();
        }


        private void tabPage1_Click(object sender, EventArgs e)
        {

        }

        private void label8_Click(object sender, EventArgs e)
        {

        }

        private void checkBoxHideSN_CheckedChanged(object sender, EventArgs e)
        {
            Program.cloud.draw.HideSN = checkBoxHideSN.Checked;
            Program.cloud.draw.DrawSensorsOfNetwork(Program.cloud.sn, true, checkBox1.Checked, true);
        }

        private void checkBoxGrahWr_CheckedChanged(object sender, EventArgs e)
        {
            Program.cloud.draw.posunGrafu = checkBoxGrahWr.Checked;
            if (!checkBoxGrahWr.Checked)
            {
                Program.cloud.draw.DrawSensorsOfNetwork(Program.cloud.sn, true, checkBox1.Checked, true);
            }
        }

        private void button10_Click(object sender, EventArgs e)
        {
                        

            double epsUh, epsConf, epsB; 
            int iter, pseudostep,rounds;
            try
            {
                epsB = Convert.ToDouble(textBoxEpsB.Text);
                epsUh = Convert.ToDouble(textBoxEpsUh.Text);
                epsConf = Convert.ToDouble(textBoxEpsConf.Text);

                iter = Convert.ToInt32(textBoxIter.Text);
                pseudostep = Convert.ToInt32(textBoxPseudStep.Text);
                rounds = Convert.ToInt32(textBoxRound.Text);
            }
            catch (FormatException)
            {
                MessageBox.Show("hodnoty zadané v nesprávnom formáte");
                nastavHodnoty();
                return;
            }
            if (epsB > 0.1 || epsUh > 0.1)
            {
                MessageBox.Show("epsilon uhlu a bodu nemôžu byť väčšie ako 0.1");
                nastavHodnoty();
                return;
            }

            if (iter > 10)
            {
                MessageBox.Show("počet iterácií by nemôže presiahnuť 10");
                nastavHodnoty();
                return;
            }

            if (pseudostep > 30)
            {
                MessageBox.Show("pseudo step nemôže byť väčší ako 30");
                nastavHodnoty();
                return;
            }

            if (epsConf > 10)
            {
                MessageBox.Show("epsilon pre po-kroky a pred-kroky nemoze byť väčší ako 10");
                nastavHodnoty();
                return;
            }

            if (rounds > 5)
            {
                DialogResult d = MessageBox.Show("Neodporúčame počet otočení siete viac ako 5.", "Napriek tomu chcete pokračovať", MessageBoxButtons.YesNo, MessageBoxIcon.Question);

                if (d != DialogResult.Yes)
                {
                    nastavHodnoty();
                    return;
                }

            }
                
            Parameters.pointDeviation = epsB;
            Parameters.angleDeviation = epsUh;
            Parameters.angleEpsilonInConf = epsConf;
            Parameters.iterations = iter;
            Parameters.angleOfPseudoStep = pseudostep;
            Parameters.countOfRot = rounds;

            nastavHodnoty();

            Program.cloud.WriteToLog("HODNOTY ZMENENE");
        }

        private void nastavHodnoty()
        {
            textBoxEpsB.Text = Parameters.pointDeviation.ToString();
            textBoxEpsUh.Text = Parameters.angleDeviation.ToString();
            textBoxEpsConf.Text = Parameters.angleEpsilonInConf.ToString();

            textBoxIter.Text = Parameters.iterations.ToString();
            textBoxPseudStep.Text = Parameters.angleOfPseudoStep.ToString();
            textBoxRound.Text = Parameters.countOfRot.ToString();
        }



        public void RequestStop()
        {
            _shouldStop = true;
            if (thread != null)
                thread.Join();
            thread = null;
        }

        private void button4_Click(object sender, EventArgs e)
        {
            makeStepBack();
            if (stepcounter >= 0 && (stepcounter < comboBox1.Items.Count))
                comboBox1.SelectedIndex = stepcounter;
        }

        private void makeStepBack()
        {
            stepcounter--;
            Program.cloud.sn.rotateNetworkAndSearchInters(stepcounter * Parameters.stepangle);
            Program.cloud.draw.DrawSensorsOfNetwork(Program.cloud.sn, true,checkBox1.Checked, true);
        }

        private void button5_Click(object sender, EventArgs e)
        {
            Color c = button3.BackColor;
            button3.BackColor = Color.FromArgb(Math.Max(c.A - 10, (byte)0), c.R, c.G, c.B);

            makeStepWithSN();
            if (stepcounter >= 0 && (stepcounter < comboBox1.Items.Count))
                comboBox1.SelectedIndex = stepcounter;
        }

        private void button11_Click(object sender, EventArgs e)
        {
            double myconst = Parameters.myconst;
            foreach (Sensor s in Program.cloud.sn.Sensors)
            {
                s.bTriangleNetPoint.x++;
                s.eTriangleNetPoint.x++;
                s.b = new MyPoint(s.bTriangleNetPoint.x * myconst, s.b.y);
                s.e = new MyPoint(s.eTriangleNetPoint.x * myconst, s.e.y);
                if (s is RSensor)
                {
                    ((RSensor)s).SetFields(s.bTriangleNetPoint, s.eTriangleNetPoint, ((RSensor)s).RotDirection, ((RSensor)s).DetectAngle);
                }

            }
            Program.cloud.sn.changed = true;
            Program.cloud.drawSN(0);

        }

        private void button12_Click(object sender, EventArgs e)
        {
            double myconst = Parameters.myconst;
            foreach (Sensor s in Program.cloud.sn.Sensors)
            {
                s.bTriangleNetPoint.x--;
                s.eTriangleNetPoint.x--;
                s.b = new MyPoint(s.bTriangleNetPoint.x * myconst, s.b.y);
                s.e = new MyPoint(s.eTriangleNetPoint.x * myconst, s.e.y);

                if (s is RSensor)
                {
                    ((RSensor)s).SetFields(s.bTriangleNetPoint, s.eTriangleNetPoint, ((RSensor)s).RotDirection, ((RSensor)s).DetectAngle);
                }
            }
            Program.cloud.sn.changed = true;
            Program.cloud.drawSN(0);
        }

        private void button14_Click(object sender, EventArgs e)
        {
            foreach (Sensor s in Program.cloud.sn.Sensors)
            {
                s.bTriangleNetPoint.y++;
                s.eTriangleNetPoint.y++;
                s.b.y++;
                s.e.y++;
                if (s is RSensor)
                {
                    ((RSensor)s).SetFields(s.bTriangleNetPoint, s.eTriangleNetPoint, ((RSensor)s).RotDirection, ((RSensor)s).DetectAngle);
                }

            }
            Program.cloud.sn.changed = true;
            Program.cloud.drawSN(0);
        }

        private void button13_Click(object sender, EventArgs e)
        {
            foreach (Sensor s in Program.cloud.sn.Sensors)
            {
                s.bTriangleNetPoint.y--;
                s.eTriangleNetPoint.y--;
                s.b.y --;// = new MyPoint(s.b.x, s.b.y - 1);
                s.e.y --;// = new MyPoint(s.e.x, s.e.y - 1);
                if (s is RSensor)
                {
                    ((RSensor)s).SetFields(s.bTriangleNetPoint, s.eTriangleNetPoint, ((RSensor)s).RotDirection, ((RSensor)s).DetectAngle);
                }

            }
            Program.cloud.sn.changed = true;
            Program.cloud.drawSN(0);
        }

        private void nováSieťToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (!PlayActive)
            {
                DialogResult d = MessageBox.Show("Naozaj chcete zahodiť aktuálnu siet a vytvoriť novú?", "Potvrdenie", MessageBoxButtons.YesNo, MessageBoxIcon.Question);

                if (d == DialogResult.Yes)
                {
                    Program.cloud.sn.clearNetwork();
                }
                FormAction.drawSN();
            }
        }
    }
}
