﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace WindowsFormsApplication1.Graph
{
    class GraphAlg<T>
    {
        public static List<List<T>> GetComponents(Graph<T> graph)
        {
            List<List<T>> result = new List<List<T>>();
            visited = new List<Vertex<T>>();
            foreach (Vertex<T> v in graph.Vertices)
            {
                if (!visited.Contains(v))
                {
                   
                    component= new List<T>();
                    GetComponentWithVertex(v, graph);
                    result.Add(component);
                }
            }
            return result;
        }

        static List<Vertex<T>> visited;
        static List<T> component;

        public static void GetComponentWithVertex(Vertex<T> v, Graph<T> graph)
        {
            if (!visited.Contains(v))
            {
                component.Add(v.Data);
                visited.Add(v);
                foreach (Vertex<T> n in graph.neighbours(v))
                {
                    GetComponentWithVertex(n,graph);
                }
            }
        }
    }
}
