﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using WindowsFormsApplication1.SNetwork;
using WindowsFormsApplication1.MyMath;

namespace WindowsFormsApplication1.Graph
{
    class GraphOthers
    {
        internal static bool hasCommonOriginalHalfEdge(List<SNetwork.SPoint> List1, List<SNetwork.SPoint> List2Bigger)
        {
            for (int i = 0; i < List1.Count(); i++)
            {
                if (hasEdge(List1.ElementAt(i), List1.ElementAt((i + 1) % List1.Count), List2Bigger))
                {
                    return true;
                }
            }
            return false;
        }

        private static bool hasEdge(SNetwork.SPoint sPoint, SNetwork.SPoint sPoint_2, List<SNetwork.SPoint> List)
        {
            for (int j = 0; j < List.Count(); j++)
            {
                if (List.ElementAt(j).Equals(sPoint) &&  List.ElementAt((j+1)%List.Count()).Equals(sPoint_2))
                {
                    return true;
                }
            }
            return false;
        }

        class NewEdges
        {
            public Vertex<SPoint> vv1, vv2;
            public SPoint sp;

            public NewEdges(Vertex<SPoint> vv1,Vertex<SPoint> vv2,SPoint sp){
                this.vv1=vv1;
                this.vv2=vv2;
                this.sp=sp;
            }
        }

        internal static void addExtraEdge(SPoint sp1, SPoint sp2, int p, Graph<SPoint> graph)
        {
            Vertex<SPoint> v1 = graph.GetVertexWithData(sp1);
            Vertex<SPoint> v2 = graph.GetVertexWithData(sp2);

            addExtraEdge(v1, v2, p, graph);
        }

        internal static void addExtraEdge(Vertex<SPoint> v1, Vertex<SPoint> v2, int p, Graph<SPoint> graph)
        {

            if (v1.Equals(v2))
                return;

            graph.addEdge(v1, v2);

            if (!v1.ExtraEdges.Contains(v2))
            {
                v1.ExtraEdges.Add(v2);
                v2.ExtraEdges.Add(v1);

                v1.ExtraEdgeIndex.Add(v2.Index, p);
                v2.ExtraEdgeIndex.Add(v1.Index, p);
            }
        }
    }
}
