﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using WindowsFormsApplication1.Events;
using WindowsFormsApplication1.SNetwork;
using System.Diagnostics;

namespace WindowsFormsApplication1.Main
{
    class MainClass
    {

        public static List<Event> AllEvents = null;
        public static List<Configuration> Configurations = new List<Configuration>();
        public static List<Configuration> AdditionalConfigs = null;



        public static void mainAlg()
        {
            Stopwatch stopWatch = new Stopwatch();
            stopWatch.Start();

            Program.cloud.WriteToLog("Hľadám udalosti... som na úseku medzi uhlami:");
            AllEvents = EventSearch.getEvents(Program.cloud.sn, Parameters.angleOfPseudoStep, Parameters.iterations);

            stopWatch.Stop();
            Program.cloud.WriteToLog("čas hľadania udalostí:" + stopWatch.Elapsed.ToString());

            Configurations= ConfigurationsCreate.configurationsCreate(AllEvents);

            Program.cloud.WriteToLog("Počítam konfigurácie a vzťahy oblastí");

            AdditionalConfigs = ConfigurationsCreate.additionalConfigsCreate(Configurations,AllEvents);// new List<Configuration>();

            EquivalenceSearch.computeSPEquivalences(Configurations, AdditionalConfigs, AllEvents);

            GraphCreate.makeSpecialGraphs(Configurations, AdditionalConfigs);

            SAreasSearch.searchSpecialAreas(AdditionalConfigs);

            EqOfSAreasSearch.searchSAreasRelationships(Configurations, AdditionalConfigs);

            Configuration ClearConf= Configuration.getConfWithAllClear(Configurations);

            Program.cloud.draw.writeGraph = false;
            Program.cloud.drawSN(0);
            Program.cloud.draw.writeGraph = true;
            if (ClearConf == null)
            {
                Program.cloud.WriteToLog("Ani jedna konfigurácia nemá vš. vnútorné jednoduché oblasti čisté");
            }
            else
            {
                Program.cloud.WriteToLog("V konfigurácii pre uhol " + ClearConf.angle + " sú čisté všetky vnútorné jedn. oblasti");
            }

            //Configuration.createConfForEveryAngle(Parameters.stepangle);

        }

        public static void ClearAll()
        {
            AllEvents = null;
            Configurations = new List<Configuration>();
            AdditionalConfigs = null;
        }
    }
}
