﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace WindowsFormsApplication1.MyMath
{
    public class MyLineSegment
    {
        public MyPoint b;
        public MyPoint e;

        public override bool Equals(Object obj)
        {
            double dev = Parameters.pointDeviation;
            if (!(obj is MyLineSegment)) return false;
            MyLineSegment s = (MyLineSegment)obj;

            if (Distances.distance(this.b, s.b) < dev && Distances.distance(this.e, s.e) < dev)
                return true;

            if (Distances.distance(this.b, s.e) < dev && Distances.distance(this.e, s.b) < dev)
                return true;

            return false;
        }

        public override string ToString()
        {
            return "[b: " + b.ToString() + ",e: " + e.ToString() + "]";
        }

        public MyLineSegment(MyPoint b, MyPoint e)
        {
            this.b = new MyPoint(b);
            this.e = new MyPoint(e);
        }

        public MyLineSegment(double x1, double y1, double x2, double y2)
        {
            this.b = new MyPoint(x1, y1);
            this.e = new MyPoint(x2, y2);
        }

        public MyLineSegment()
        {

        }

        public MyLineSegment(MyLineSegment ls)
        {

            this.b =  new MyPoint(ls.b);
            this.e =  new MyPoint(ls.e);

        }

        public override int GetHashCode()
        {
            return base.GetHashCode();
        }

        public double getLength()
        {
            return Distances.distance(b, e);
        }
    }
}
