﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Drawing;

namespace WindowsFormsApplication1.MyMath
{
    public class MyPoint
    {
        public double x { get; set; }
        public double y { get; set; }

        public MyPoint(double x, double y)
        {
            this.x = x;
            this.y = y;
        }

        public MyPoint(MyPoint b)
        {
            this.x = b.x;
            this.y = b.y;
        }

        public Point ToPoint()
        {
            double m = Parameters.RowHeight * Parameters.scaleFactor;
            return new Point((int)(x*m), (int)(y*m));
        }

        public Point ToPoint(int PosunX, int PosunY)
        {
            double m = Parameters.RowHeight * Parameters.scaleFactor;
            return new Point((int)(x * m) - PosunX, (int)(y * m) - PosunY);
        }

        public override string ToString()
        {

            return "(" + Math.Round(x / Parameters.myconst, 3) + "; " + Math.Round(y, 3) + ")";
        }

        public override bool Equals(Object obj)
        {
            if (!(obj is MyPoint)) return false;
            MyPoint p = (MyPoint)obj;
            if (Distances.distance(p, this) <= Parameters.pointDeviation)
            {
                return true;
            }
            else return false;
        }

        public override int GetHashCode()
        {
            return base.GetHashCode();
        }

    }
}
