﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using WindowsFormsApplication1.SNetwork;
using System.Drawing;


namespace WindowsFormsApplication1.MyMath
{
    class Possitions
    {


       
        internal static bool lieInPolygon(List<SPoint> Polygon, SNetwork.SPoint vyrastok)
        {
            int polySides = Polygon.Count;

            MyPoint[] polyP = new MyPoint[polySides];
                        
            int c =0;
            foreach (SPoint sp in Polygon)
            {
                polyP[c] = sp.Location;              
                c++;
            }
            return InsidePolygon(polyP, polySides, vyrastok.Location);
        }

        //prevzate z http://bbs.dartmouth.edu/~fangq/MATH/download/source/Determining%20if%20a%20point%20lies%20on%20the%20interior%20of%20a%20polygon.htm
        public static bool InsidePolygon(MyPoint[] polygon, int N, MyPoint p)
        {


            int counter = 0;
            int i;
            double xinters;
            MyPoint p1, p2;

            p1 = polygon[0];
            for (i = 1; i <= N; i++)
            {
                p2 = polygon[i % N];
                if (p.y > Math.Min(p1.y, p2.y))
                {
                    if (p.y <= Math.Max(p1.y, p2.y))
                    {
                        if (p.x <= Math.Max(p1.x, p2.x))
                        {
                            if (p1.y != p2.y)
                            {
                                xinters = (p.y - p1.y) * (p2.x - p1.x) / (p2.y - p1.y) + p1.x;
                                if (p1.x == p2.x || p.x <= xinters)
                                    counter++;
                            }
                        }
                    }
                }
                p1 = p2;
            }

            if (counter % 2 == 0)
                return (false);
            else
                return (true);
        }


        internal static bool lieOnBorder(List<SPoint> Out, SPoint sp)
        {
            for (int i = 0; i < Out.Count(); i++)
            {
                if (lieOnLineSegment(Out.ElementAt(i), Out.ElementAt((i + 1) % Out.Count()), sp))
                    return true;
            }
            return false;
        }

        internal static bool lieOnLineSegment(SPoint x, SPoint y, SPoint sp){

            if (Distances.distancePointLineSegment(x.Location, y.Location, sp.Location) < Parameters.pointDeviation)
                return true;

            return false; 

        }

        internal static bool lieInPolygon(List<SPoint> Sublist, MyPoint middle)
        {
            return lieInPolygon(Sublist, new SPoint(null, null, null, 0, middle));
        }

        internal static bool lieOnBorder(List<SPoint> Sublist, MyPoint middle)
        {
            return lieOnBorder(Sublist, new SPoint(null, null, null, 0, middle));
        }



        public static double PolygonArea(List<SPoint> Polygon)
        {
            int polySides = Polygon.Count;

            MyPoint[] polyP = new MyPoint[polySides];
                        
            int c =0;
            foreach (SPoint sp in Polygon)
            {
                polyP[c] = sp.Location;              
                c++;
            }
            return PolygonArea(polyP);
        }

        static double PolygonArea(MyPoint[] polygon)
        {
            int i, j;
            double area = 0;

            for (i = 0; i < polygon.Length; i++)
            {
                j = (i + 1) % polygon.Length;

                area += polygon[i].x * polygon[j].y;
                area -= polygon[i].y * polygon[j].x;
            }
            area /= 2;
            return (area < 0 ? -area : area);
        }
    }
}
