﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace WindowsFormsApplication1.MyMath
{
    public class Vector
    {

        public double _x;
        public double _y;

        Vector()
        {
            _x = 0;
            _y = 0;
        }

        public Vector(double x, double y)
        {
            _x = x;
            _y = y;
        }

        public static Vector operator +(Vector v1, Vector v2)
        {
            return new Vector(v1._x + v2._x, v1._y + v2._y);
        }

        public static Vector operator -(Vector v1, Vector v2)
        {
            return new Vector(v1._x - v2._x, v1._y - v2._y);
        }

        public static Vector operator *(Vector v1, double f)
        {
            return new Vector(v1._x * f, v1._y * f);
        }

        public double DistanceToSquared(Vector p)
        {
            double dX = p._x - this._x;
            double dY = p._y - this._y;
            return dX * dX + dY * dY;
        }

        public double DistanceTo(Vector p)
        {
            return Math.Sqrt(this.DistanceToSquared(p));
        }

        public double DotProduct(Vector p)
        {
            return this._x * p._x + this._y * p._y;
        }
    }
}
