﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using WindowsFormsApplication1.Events;
using WindowsFormsApplication1.MyMath;

namespace WindowsFormsApplication1.SNetwork
{
    public class SPoint
    {
        public int GraphIndex=-1;
        private List<SPoint> EquivalentSPoints = new List<SPoint>(10);
        public List<SPoint> ForAddEqSPs = new List<SPoint>(10);
        public List<Sensor> Owners = new List<Sensor>(5);
        public List<Sensor> OwnersEnd = new List<Sensor>(3);
        public List<Sensor> OwnersBeg = new List<Sensor>(3);
        public double Angle;
        public MyPoint Location;
        public bool inters = false;
        public bool end = false;
        public bool beginning = false;
        public bool speacial = false;
        public bool AddedAsEventLocation = false;

        public SPoint(List<Sensor> Owners, List<Sensor> OwnersBeg, List<Sensor> OwnersEnd, double Angle, MyPoint location)
        {
            if (Owners != null)
                this.Owners = Owners.ToList();
            if (OwnersBeg != null)
                this.OwnersBeg = OwnersBeg.ToList();
            if (OwnersEnd != null)
                this.OwnersEnd = OwnersEnd.ToList();
            this.Angle = Angle;
            this.Location = location;
        }

        public void AddOwners(List<Sensor> list)
        {
            if (list == null)
                throw new Exception("zoznam vlastnikov je null!");
            foreach (Sensor s in list)
                AddOwner(s);
        }

        public void AddOwner(Sensor s)
        {
            if (!Owners.Contains(s))
                Owners.Add(s);
        }

        public void AddOwnerBeg(Sensor s)
        {
            if (!OwnersBeg.Contains(s))
                OwnersBeg.Add(s);
        }

        public void AddOwnerEnd(Sensor s)
        {
            if (!OwnersEnd.Contains(s))
                OwnersEnd.Add(s);
        }

        public List<Sensor> getCommonOwners(SPoint sp2)
        {
            return getCommon(this.Owners, sp2.Owners);
        }

        public List<Sensor> getCommonOwnersBeg(SPoint sp2)
        {
            return getCommon(this.OwnersBeg, sp2.OwnersBeg);
        }

        public List<Sensor> getCommonOwnersEnd(SPoint sp2)
        {
            return getCommon(this.OwnersEnd,sp2.OwnersEnd);
        }

        public static List<Sensor> getCommon(List<Sensor> list1, List<Sensor> list2)
        {
            List<Sensor> result = new List<Sensor>(10);
            foreach (Sensor s in list1)
            {
                if (list2.Contains(s))
                {
                    result.Add(s);
                }
            }
            return result;
        }

        public void addEqSPs(List<SPoint> sps)
        {
            foreach (SPoint sp in sps)
                addEqSP(sp);
        }

        public void addEqSP(SPoint sp)
        {
            if (!EquivalentSPoints.Contains(sp))
            {
                EquivalentSPoints.Add(sp);
            }
        }

        public void addForAddEqSPs(List<SPoint> sps)
        {
            foreach (SPoint sp in sps)
                addForAddEqSP(sp);
        }

        public void addForAddEqSP(SPoint sp)
        {
            if (!ForAddEqSPs.Contains(sp))
            {
                ForAddEqSPs.Add(sp);
            }
        }

        public bool hasEqSP(SPoint sp)
        {
            if (EquivalentSPoints.Contains(sp))
                return true;
            else
                return false;
        }

        /// <summary>
        /// vrati true plati ekv. posunutia podla definicie
        /// </summary>
        /// <param name="sp">SP nasledovny tomuto SP</param>
        /// <returns></returns>
        public bool IsItEquivalentNextSPoint(SPoint sp,List<Event> Separs)
        {

            if (this.beginning && sp.beginning && this.getCommonOwnersBeg(sp).Count > 0) return true;
            if (this.end && sp.end && this.getCommonOwnersEnd(sp).Count > 0) return true;


             List<Sensor> commOwners =this.getCommonOwners(sp);
             if (this.getCommonOwners(sp).Count > 1)
             {
                 if (EquivalenceSearch.areTwoWithoutSepar(commOwners, Separs))
                 {
                     return true;
                 }
             }

             if (sp.ForAddEqSPs.Contains(this) || this.ForAddEqSPs.Contains(sp))
             {
                 return true;
             }

            //este skusime spec. ekvivalenciu na pridanych bodoch ako lok. udalosti
             return false;
        }

      
        /// <summary>
        /// Funkcia, ktora vyberie zo zonamu listOfSp(vs. SP zo zoznamu musia mat rovnaky uhol) len tie SP (nasledujuce), ktore su ekv s tymto SP a vrati zoznam vybranych
        /// </summary>
        /// <param name="listOfSp">zoznam nasledujucich SP (vs. maju rovnaky uhol)</param>
        /// <param name="events">zoznam udalosti, ktore sa deju medzi uhlami SP zo zoznamu uholm tohto SP</param>
        /// <returns>zoznam prvkov, ktore su ekvivalente (nasledovne) SP</returns>
        public List<SPoint> ComputeEqSPointsNext(List<SPoint> listOfSp, List<Event> Separs)
        {
            List<SPoint> listOfEq = new List<SPoint>(5);
            foreach (SPoint sp in listOfSp)
            {
                if (this.IsItEquivalentNextSPoint(sp, Separs))
                    listOfEq.Add(sp);
            }
            return listOfEq;
        }

        /// <summary>
        /// Ak sa rovnaju pozicie a uhly, potom su ekv. sp
        /// </summary>
        public override bool Equals(Object obj)
        {
            double angleDev = Parameters.angleDeviation;
            if (!(obj is SPoint)) return false;
            SPoint s = (SPoint)obj;
            if (Math.Abs(s.Angle % 360 - this.Angle % 360) < angleDev && s.Location.Equals(this.Location))
                return true;
            return false;
        }

        public override int GetHashCode()
        {
            return base.GetHashCode();
        }

        public override string ToString()
        {
            if (GraphIndex==-1)
                return "SP: loc " + Location.ToString() + ";angle " + this.Angle.ToString() + ";end " + end.ToString() + ";beg " + beginning.ToString() + ";inters " + inters.ToString();
            else
                return "SP:" + GraphIndex.ToString()+  " loc " + Location.ToString() + ";angle " + this.Angle.ToString() + ";end " + end.ToString() + ";beg " + beginning.ToString() + ";inters " + inters.ToString();
            
        }

        internal List<SPoint> getEqSPsWithAngle(double angle)
        {
            List<SPoint> EqSPs = new List<SPoint>(3);
            if (EquivalentSPoints == null || EquivalentSPoints.Count==0)
                return EqSPs;

            foreach (SPoint EqSP in EquivalentSPoints)
            {
                if (Angles.sameAngles(EqSP.Angle,angle))
                {
                    EqSPs.Add(EqSP);
                }
            }

            return EqSPs;
        }

        internal List<SPoint> getAllEqSPs()
        {
            return EquivalentSPoints.ToList();
        }
    }
}
