﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using WindowsFormsApplication1.Events;
using WindowsFormsApplication1.MyMath;

namespace WindowsFormsApplication1.SNetwork
{
    class ConfigurationsCreate
    {

        public static List<Configuration> configurationsCreate(List<Event> allEvents)
        {
            SNetwork sn = Program.cloud.sn;
            List<Configuration> Congigurations = new List<Configuration>(20);
            SAreasSearch.areaIndex = 0;

            //zistime uhly
            List<double> allAngles = getAnglesOfEvents(allEvents);
            allAngles.Sort();
            List<double> allAnglesOrigin = allAngles.ToList();

            for (int i = 1; i < Parameters.countOfRot; i++)
            {
                foreach (double angle in allAnglesOrigin)
                {
                    allAngles.Add(angle + (i * 360));
                }
            }

            Program.cloud.WriteToLog("NÁJDENÉ KROKY: ");
            foreach (double e in allAngles)
            {
                if (e < 360 + Parameters.angleOfPseudoStep)
                    Program.cloud.WriteToLog(e.ToString());
            }

            //pre kazdy krok vytvorime konfiguraciu
            foreach (double e in allAngles)
            {
                Congigurations.Add(Configuration.makeConfiguration(e, sn, allEvents,null));
            }

            return Congigurations;
        }

        public static List<double> getAnglesOfEvents(List<Event> listEv)
        {
            List<double> allAngles = new List<double>(20);
            foreach (Event ev in listEv)
            {
                if (!existAngleInList(ev.angle,allAngles))
                {
                    allAngles.Add(ev.angle);
                }
            }
            return allAngles;
        }

        private static bool existAngleInList(double p, List<double> allAngles)
        {
            foreach (double d in allAngles)
            {
                if (Angles.sameAngles(p, d)) return true;
            }
            return false;
        }

        internal static List<Configuration> additionalConfigsCreate(List<Configuration> Configurations,  List<Event> AllEvents)
        {

            List<Event> EventsToAddSP = new List<Event>();
            List<Configuration> result = new List<Configuration>(Configurations.Count * 3);
            double angle;
            SNetwork sn = Program.cloud.sn;
            double epsilon = Parameters.angleEpsilonInConf;
            Configuration First, Secound;

            //ak nie su apson dve, nema zmysel vytvarat pomocne konfiguracie
            if (Configurations.Count < 2)
                return result;

            //pre kazdu konfiguraciu vytvorime 3 nove: epsilon za, vstrede a epsilon pred nasledujucou
            for (int i = 0; i < Configurations.Count; i++)
            {
                First = Configurations.ElementAt(i);
                Secound = Configurations.ElementAt((i + 1) % Configurations.Count);
                EventsToAddSP = EventSearch.getEventsToAdd(First, Secound, AllEvents);

                //pridame konf. po prvej konf. plus epsilon
                angle = First.angle + epsilon;
                angle = angle % (360*Parameters.countOfRot);
                result.Add(Configuration.makeConfiguration(angle, sn, null, EventsToAddSP));

                //pridame konfiguraciu medzi prvou a druhou konf.
                if (First.angle < Secound.angle)
                {
                    angle = First.angle + ((Secound.angle - First.angle) / 2);
                }
                //ak nasledovna je s mensim uhlom, teda prejdeme cez 360
                else
                {
                    angle = (First.angle + (((360 * Parameters.countOfRot - First.angle) + Secound.angle) / 2)) % (360 * Parameters.countOfRot);
                }
                result.Add(Configuration.makeConfiguration(angle, sn, null, EventsToAddSP)); 

                //pridame konf. pred druhov konf.
                angle = Secound.angle - epsilon;
                if (angle<0)
                    angle = 360*Parameters.countOfRot + angle;
                result.Add(Configuration.makeConfiguration(angle, sn, null, EventsToAddSP));  
            }
            return result;
        }
    }
}
