﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using WindowsFormsApplication1.Graph;
using WindowsFormsApplication1.MyMath;

namespace WindowsFormsApplication1.SNetwork
{
    class GraphCreate
    {
        

        public static Graph<SPoint> makeSpecialGraph(Configuration conf)
        {
            Program.cloud.sn.rotateNetworkAndSearchInters(conf.angle);

            Graph<SPoint> IndGraph = new Graph<SPoint>();
            SPoint spHelp;
            SPoint spE;
            SPoint spB;
            foreach (Sensor s in conf.Sensors)
            {
                //pridame vrchol, ktory je zaciatkom senzora s
                spB = conf.GetSPWithLoc(s.b);
                if (spB == null)
                {
                    throw new Exception("Musi existovat taky SP s lokalizaciou s.b");
                }
                IndGraph.addVertex(spB);

                //pridame vrchol, ktory je koncom senzora s
                spE = conf.GetSPWithLoc(s.e);
                if (spE == null)
                {
                    throw new Exception("Musi existovat taky SP s lokalizaciou s.e");
                }
                IndGraph.addVertex(spE);

                //prejdeme vsetky vnutorne body senzora (ak niektory je koniec, al. zaciatok s - nevadi)
                SPoint prev = spB;
                foreach (MyPointWithDist mp in s.ActualSPsWithDist)
                {
                    spHelp = conf.GetSPWithLoc(mp.location);

                    IndGraph.addVertex(spHelp);
                    IndGraph.addEdge(prev, spHelp);
                    prev = spHelp;

                }

                if (s.ActualSPsWithDist.Count == 0)
                    IndGraph.addEdge(spB, spE);
                else
                {
                    IndGraph.addEdge(prev, spE);
                }
            }

            foreach (SPoint sp in conf.SPs)
            {
                sp.GraphIndex = IndGraph.GetIndexOfVertexWithData(sp);
            }
            //CycleFinding.SortEdgesClockWise(IndGraph);

            return IndGraph;
        }

        /// <summary>
        /// Skontrolujte, ci pred volanim vytvorenia grafu je spravne natocena cela siet
        /// </summary>
        /// <param name="conf"></param>
        /// <returns></returns>
        public static Graph<SPoint> makeGraph(Configuration conf)
        {
            Graph<SPoint> IndGraph = new Graph<SPoint>();
            SPoint spHelp;
            SPoint spE;
            SPoint spB;
            foreach (Sensor s in conf.Sensors)
            {
                //pridame vrchol, ktory je zaciatkom senzora s
                spB = conf.GetSPWithLoc(s.b);
                if (spB == null)
                {
                    throw new Exception("Musi existovat taky SP s lokalizaciou s.b");
                }
                IndGraph.addVertex(spB);

                //pridame vrchol, ktory je koncom senzora s
                spE = conf.GetSPWithLoc(s.e);
                if (spE == null)
                {
                    throw new Exception("Musi existovat taky SP s lokalizaciou s.e");
                }
                IndGraph.addVertex(spE);

                //prejdeme vsetky vnutorne body senzora (ak niektory je koniec, al. zaciatok s - nevadi)
                SPoint prev = spB;
                foreach (MyPointWithDist mp in s.ActualSPsWithDist)
                {
                    spHelp = conf.GetSPWithLoc(mp.location);

                    IndGraph.addVertex(spHelp);
                    IndGraph.addEdge(prev, spHelp);
                    prev = spHelp;

                }

                if (s.ActualSPsWithDist.Count == 0)
                    IndGraph.addEdge(spB, spE);
                else
                {
                    IndGraph.addEdge(prev, spE);
                }
            }

            foreach (SPoint sp in conf.SPs)
            {
                sp.GraphIndex = IndGraph.GetIndexOfVertexWithData(sp);
            }

            return IndGraph;
        }

        public static void makeSpecialGraphs(List<Configuration> confs, List<Configuration> addconfs)
        {
            if (confs.Count < 2)
                return;
            Configuration addconf;
            for (int i=0; i< confs.Count;i++)
            {
                addconf = addconfs.ElementAt(i * 3);
                addconf.SpecialGraph = makeSpecialGraphToNextAddConf(addconf, confs.ElementAt(i));
              //  addconf.SpecialGraphReducted = makeReductedSpecialGraph(addconf, confs.ElementAt(i));
                addconf.SpecialGraph.findComponents();

                addconf = addconfs.ElementAt((i * 3) + 2);
                addconf.SpecialGraph = makeSpecialGraphToNextAddConf(addconf, confs.ElementAt((i + 1) % confs.Count));
                addconf.SpecialGraph.findComponents();
             //   addconf.SpecialGraphReducted = makeReductedSpecialGraph(addconf, confs.ElementAt((i + 1) % confs.Count));
                   
            }
        }


        private static Graph<SPoint> makeSpecialGraphToNextAddConf(Configuration nextaddconf, Configuration conf)
        {
           // SNetwork specSN = Program.cloud.sn.CreateCopy();
            //staticke prepocitat po tychto upravach v povodne sn
            Program.cloud.sn.rotateNetworkAndSearchInters(nextaddconf.angle);

            Graph<SPoint> specialGraph = nextaddconf.InductedGraph.copyGraph();  // GraphCreate.makeGraph(nextaddconf);

            specialGraph.angleOfConf = conf.angle;
            List<SPoint> EqSPs;
            List<Vertex<SPoint>> Neigbours;
            Vertex<SPoint> vert;
            
          
            foreach (SPoint sp in conf.SPs)
            {
                EqSPs = sp.getEqSPsWithAngle(nextaddconf.angle);
                
                
                foreach (SPoint EqSP1 in EqSPs)
                {
                    //uz zbytocne
                    //specialGraph.GetVertexWithData(EqSP1).IndexOfEqPoint.Add(sp.GraphIndex);
                    foreach (SPoint EqSP2 in EqSPs)
                    {
                        if (!EqSP1.Equals(EqSP2))
                        {

                            //zoberieme susedov prveho vybraneho z ekv. sps
                            Neigbours = specialGraph.neighbours(specialGraph.GetVertexWithData(EqSP1));
                            //vypocitame index druheho vybraneho z ekv. sps
                            vert = specialGraph.GetVertexWithData(EqSP2);
                            //ak susedia eqsp1 neobsahuju vrchol s indexom vrcholu eqsp2
                            if (!Neigbours.Contains(vert))
                            {
                                GraphOthers.addExtraEdge(EqSP1, EqSP2, sp.GraphIndex,specialGraph);
                            }
                        }
                    }
                }
            }

            computeIntersectionsINGraph(specialGraph);

            return specialGraph;
        }

        class NewEdges
        {
            //konce medzi ktore sa vlozi sp 
            public Vertex<SPoint> sv1, sv2, nv1, nv2;
            public SPoint sp;
            public bool special;

            public NewEdges(Vertex<SPoint> sv1, Vertex<SPoint> sv2, Vertex<SPoint> vv1, Vertex<SPoint> vv2, SPoint sp, bool special)
            {
                this.nv1 = vv1;
                this.nv2 = vv2;
                this.sv1 = sv1;
                this.sv2 = sv2;
                this.sp = sp;
                this.special = special;
            }

            public override int GetHashCode()
            {
                return base.GetHashCode();
            }

            public override bool Equals(object obj)
            {
                if (!(obj is NewEdges)) return false;
                NewEdges s = (NewEdges)obj;
                if (s.sp.Equals(this.sp))
                {
                    if ((s.sv1.Equals(sv1) && s.sv2.Equals(sv2)) || (s.sv1.Equals(sv2) && s.sv2.Equals(sv1)))
                    {
                        if (this.nv1 == null && s.nv1 == null)
                            return true;
                        if (this.nv1.Equals(s.nv1) && this.nv2.Equals(s.nv2))
                            return true;
                        if (this.nv1.Equals(s.nv2) && this.nv2.Equals(s.nv1))
                            return true;
                    }
                }

                return false;
            }
        }

        private static void computeIntersectionsINGraph(Graph<SPoint> specialGraph)
        {
            MyPoint inters;
            Vertex<SPoint> intersV;
            SPoint intersSP;
            NewEdges NE;
            List<NewEdges> AddEdges = new List<NewEdges>();

            foreach (Vertex<SPoint> v1 in specialGraph.Vertices)
            {
                foreach (Vertex<SPoint> v2 in v1.ExtraEdges)
                {
                    

                    foreach(Vertex<SPoint> vv1 in specialGraph.Vertices)
                    {
                        if (!vv1.Equals(v1) && !vv1.Equals(v2))
                        {
                            foreach (Vertex<SPoint> vv2 in vv1.Edges)
                            {
                                //musia to byt 4 rozne body a nespecialna hrana
                                if (!vv2.Equals(v1) && !vv2.Equals(v2) && !vv2.Equals(vv1) && !vv1.ExtraEdges.Contains(vv2))
                                {
                                   

                                    inters = IntersectionMath.Intersection(v1.Data.Location, v2.Data.Location, vv1.Data.Location, vv2.Data.Location);
                                    if (inters != null)
                                    {

                                        intersSP = new SPoint(null, null, null, vv1.Data.Angle, inters);

                                        // ak je to pries na konci norm. hrany
                                        if (intersSP.Equals(vv1.Data) || intersSP.Equals(vv2.Data))
                                        {
                                            NE = new NewEdges(v1,v2, null, null, intersSP, false);
                                            if (!AddEdges.Contains(NE))
                                                AddEdges.Add(NE);
                                        }
                                        //ak to nie je pries na konci norm. hrany
                                        else
                                        {
                                            NE = new NewEdges(v1,v2,vv1, vv2, intersSP, false);
                                            if (!AddEdges.Contains(NE))
                                                AddEdges.Add(NE);
                                        }
                                    }
                                }
                            }
                        }
                    }

                    
                }
            }

            if (AddEdges.Count > 0)
            {
                foreach (NewEdges newEdge in AddEdges)
                {
                    if (newEdge.nv1 == null)
                    {
                        int index = specialGraph.getIndexOfExtraEdge(newEdge.sv1, newEdge.sv2);
                        specialGraph.deleteEdge(newEdge.sv1, newEdge.sv2);
                        intersV = specialGraph.GetVertexWithData(newEdge.sp);
                        GraphOthers.addExtraEdge(newEdge.sv1, intersV, index, specialGraph);
                        GraphOthers.addExtraEdge(newEdge.sv2, intersV, index, specialGraph);
                    }
                    else
                    {
                        int index = specialGraph.getIndexOfExtraEdge(newEdge.sv1, newEdge.sv2);
                        specialGraph.deleteEdge(newEdge.sv1, newEdge.sv2);
                        specialGraph.deleteEdge(newEdge.nv1, newEdge.nv2);

                        intersV = specialGraph.GetVertexWithData(newEdge.sp);
                        if (intersV == null)
                        {
                            intersV = specialGraph.addSpecialVertex(newEdge.sp);
                            newEdge.sp.GraphIndex = intersV.Index;
                            newEdge.sp.speacial = true;
                        }
                        GraphOthers.addExtraEdge(newEdge.sv1, intersV, index, specialGraph);
                        GraphOthers.addExtraEdge(newEdge.sv2, intersV, index, specialGraph);
                        specialGraph.addEdge(newEdge.nv2, intersV);
                        specialGraph.addEdge(newEdge.nv1, intersV);

                    }
                }
            }

        }


        
    }
}
