﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using WindowsFormsApplication1.MyMath;

namespace WindowsFormsApplication1.SNetwork
{
    class ConfigurationParts
    {

        internal static List<List<SimpleArea>> makeParts(List<SimpleArea> SAreas, Graph.Graph<SPoint> InductedGraph)
        {
            List<List<SimpleArea>> result = new List<List<SimpleArea>>();
            for (int i = 0; i < InductedGraph.Components.Count(); i++)
            {
                result.Add(new List<SimpleArea>());
            }

            foreach (SimpleArea sa in SAreas)
            {
                for (int i = 0; i < InductedGraph.Components.Count(); i++)
                {
                    //ak vrchol z oblasti patri niektoremu komponentu tak bude patrit tej casti configuracie
                    if (InductedGraph.Components.ElementAt(i).Contains(sa.V.First()))
                    {
                        result.ElementAt(i).Add(sa);
                    }
                }
            }

            for (int i = 0; i < InductedGraph.Components.Count(); i++)
            {
                findOuterForPart(result.ElementAt(i), InductedGraph.Components.ElementAt(i));
            }

            return result;
        }

        private static void findOuterForPart(List<SimpleArea> part, List<SPoint> component)
        {
            if (part.Count() == 0)
                return;
            SimpleArea founded = null;
            foreach (SimpleArea sa in part)
            {
                if (sa.outer == true)
                {
                    if (founded != null)
                    {
                        founded.outer = false;
                    }

                    founded = sa;
                    break;
                }

                if (sa.inner == false)
                {
                    if (AllSPInOrOnBorder(sa, component))
                    {
                        
                        if (founded != null)
                        {
                            double areaFound = Possitions.PolygonArea(founded.V);
                            double areaSa = Possitions.PolygonArea(sa.V);

                            if (areaFound < areaSa)
                            {
                                founded.outer = false;
                                sa.outer = true;
                                founded = sa;
                            }
 
                          //  founded = (Possitions.PolygonArea(founded.V) > Possitions.PolygonArea(sa.V)) ? founded : sa;     
                        }
                        else
                        {
                           sa.outer = true;
                           founded = sa;
                        }
                    }
                }
            }

            if (founded == null)
            {
                throw new Exception("nenasli sme vonkajsiu oblast pre dany komponent/particiu");
            }

            foreach (SimpleArea sa in part)
            {
                if (sa.outer == false && sa.inner== false)
                {
                    sa.inner = true;
                }
            }
        }

        private static bool AllSPInOrOnBorder(SimpleArea sa, List<SPoint> component)
        {
            foreach (SPoint sp in component)
            {
                //ak nelezi vo vnutri ani na hranici polygonu sa, tak ex. sp mimo polygonu tejto oblasti
                if (!Possitions.lieInPolygon(sa.Polygon, sp) && !Possitions.lieOnBorder(sa.Polygon, sp))
                {
                    return false;
                }
            }

            return true;
        }
    }
}
