﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using WindowsFormsApplication1.Events;
using WindowsFormsApplication1.MyMath;

namespace WindowsFormsApplication1.SNetwork
{
    class ModifySN
    {
        public class MPWDWithSensor
        {
            public MyPointWithDist mpwd;
            public Sensor sensor;
            public MPWDWithSensor(MyPointWithDist mpwd,
             Sensor sensor)
            {
                this.mpwd = mpwd;
                this.sensor = sensor;
            }
        }


        public static void IntegrateEventsInSN(List<Event> evs, SNetwork sn)
        {
            List<MPWDWithSensor> toAddMPWS = new List<MPWDWithSensor>();
            MPWDWithSensor mpws = null;
            double oldAngle = sn.actualAngle;

            foreach (Event ev in evs)
            {
                //odkomentovat pre pridavnie koncov prekryti
                if (ev.type == Event.OVERLAP)
                {
                  /* foreach (MPWDWithSensor mpwdws in IntegrateOverlapInSN(ev, sn, oldAngle))
                    {
                        toAddMPWS.Add(mpwdws);
                    }*/


                }
                else
                {
                    mpws = IntegrateEventInSN(ev, sn, oldAngle);
                    if (mpws!=null)
                      toAddMPWS.Add(mpws);
                }
            }

            sn.rotateNetworkAndSearchInters(oldAngle);

            foreach (MPWDWithSensor mpwtoadd in toAddMPWS)
            {
                foreach (Sensor s in sn.Sensors)
                {
                    if (s.Equals(mpwtoadd.sensor))
                    {
                        s.addMyPointWithDist(mpwtoadd.mpwd);
                      //  mpwtoadd.mpwd.SpecialOwner = s;
                        s.ActualSPsWithDist.Sort();
                    }
                }                
            }
               
        }

        private static List< MPWDWithSensor> IntegrateOverlapInSN(Event ev, SNetwork sn, double originalRotate)
        {
                      
            if (ev==null)
               return null;
            //zapamatame si uhol SN, do ktoreho ju dame nakoniec
            double oldAngle = originalRotate; //sn.actualAngle;
            //otocime SN na dany uhol eventu...
            sn.rotateNetwork(ev.angle);
            if (ev.Acters.Count()!= 2  || ev.type==Event.UNDEFINED){
                return null;
            }

            // zistime, kde sa na senzore nachadza ten event (vzd. od konca)
            Sensor Sensor1 = ev.Acters.ElementAt(0);
            Sensor Sensor2 = ev.Acters.ElementAt(1);

            List<Overlap> overlaps = sn.getActualOverlaps();
            Overlap ovlWanted = null;
            foreach (Overlap ovl in overlaps)
            {
                if (ovl.Acters.Contains(Sensor1) && ovl.Acters.Contains(Sensor2))
                {
                    ovlWanted = ovl;
                    break;
                }
            }

            if (ovlWanted == null)
                return null;

             //zistime, ci ktory hranicny bod senzorov je hranicny prekreytia
             List<MPWDWithSensor> result = new  List<MPWDWithSensor>(2);
             bool LieEndOnEndS1 = ovlWanted.ls.e.Equals(Sensor1.b) || (ovlWanted.ls.e.Equals(Sensor1.e)) ;
             bool LieEndOnEndS2 = ovlWanted.ls.e.Equals(Sensor2.b) || (ovlWanted.ls.e.Equals(Sensor2.e)) ;
             bool LieBegOnEndS1 = ovlWanted.ls.b.Equals(Sensor1.b) || (ovlWanted.ls.b.Equals(Sensor1.e)) ;
             bool LieBegOnEndS2 = ovlWanted.ls.b.Equals(Sensor2.b) || (ovlWanted.ls.b.Equals(Sensor2.e)) ;
            
             //ak je jeden koniec mimo hran bodov s1
             if (!LieEndOnEndS1 || !LieBegOnEndS1)
             {
                 MyPoint mpw = (!LieEndOnEndS1) ? ovlWanted.ls.e : ovlWanted.ls.b;
                 double distBeg = MyMath.Distances.distance(Sensor1.b, mpw);
                 double length = Sensor1.getLength();
                 double VecSize = distBeg / length;

                 sn.rotateNetwork(oldAngle);
                 MyPoint mp = new MyPoint(Sensor1.b.x + VecSize * (Sensor1.e.x - Sensor1.b.x), Sensor1.b.y + VecSize * (Sensor1.e.y - Sensor1.b.y));
                 MyPointWithDist mpWD = new MyPointWithDist(mp,distBeg);
                 mpWD.AddedAsEventLocation = true;
                 mpWD.ForAddeqSPs.Add(new SPoint(null, null, null, ev.angle, mpw));
              //   mpWD.addActers(Sensor1,Sensor2);

                 result.Add(new MPWDWithSensor(mpWD, Sensor1));
             }

             if (!LieEndOnEndS2 || !LieBegOnEndS2)
             {
                 MyPoint mpw = (!LieEndOnEndS2) ? ovlWanted.ls.e : ovlWanted.ls.b;
                 double distBeg = MyMath.Distances.distance(Sensor2.b, mpw);
                 double length = Sensor2.getLength();
                 double VecSize = distBeg / length;

                 sn.rotateNetwork(oldAngle);
                 MyPoint mp = new MyPoint(Sensor2.b.x + VecSize * (Sensor2.e.x - Sensor2.b.x), Sensor2.b.y + VecSize * (Sensor2.e.y - Sensor2.b.y));
                 MyPointWithDist mpWD = new MyPointWithDist(mp, distBeg);
                 mpWD.AddedAsEventLocation = true;
                 mpWD.ForAddeqSPs.Add(new SPoint(null, null, null, ev.angle, mpw));
            //     mpWD.addActers(Sensor1, Sensor2);

                 result.Add(new MPWDWithSensor(mpWD, Sensor2));
             }
             return result;
        }


        public static MPWDWithSensor IntegrateEventInSN(Event ev, SNetwork sn, double originalRotate)
        {
            
            if (ev==null)
               return null;
            //zapamatame si uhol SN, do ktoreho ju dame nakoniec

            double oldAngle = originalRotate; 
            //otocime SN na dany uhol eventu...
            sn.rotateNetwork(ev.angle);
            if (ev.Acters.Count() != 2 || ev.type == Event.UNDEFINED || ev.type == Event.OVERLAP)
            {
                return null;
            }

            // zistime, kde sa na senzore nachadza ten event (vzd. od konca)
            Sensor SensorWithEvent1 = ev.Acters.ElementAt(0);
            Sensor SensorWithEvent2 = ev.Acters.ElementAt(1);
  
            //senzor na ktorom bude lezat event mimo koncov bude ten, ktoreho konce budu od miesta eventu dalej
            bool LieOnEndOfS1 = (ev.location.Equals(SensorWithEvent1.b) || ev.location.Equals(SensorWithEvent1.e));
            bool LieOnEndOfS2 = (ev.location.Equals(SensorWithEvent2.b) || ev.location.Equals(SensorWithEvent2.e));

            Sensor SensorWanted = null;
            //kvoli nepresnosti moze event byt na mieste, ktore nie je koncom ani jedneho senzora
            //vtedy hladanym bude ten, ktoreho koniec je dalej od toho eventu
            if (!LieOnEndOfS1 && !LieOnEndOfS2)
            {
                Program.cloud.WriteToLog("NEVYHODNOTÉ SPRÁVNE: skúste zvýšiť presnosť (počet delení)");

                double distEndOfS1 = MyMath.Distances.distance(SensorWithEvent1.e, ev.location);
                double distBegOfS1 = MyMath.Distances.distance(SensorWithEvent1.b, ev.location);
                double distEndOfS2 = MyMath.Distances.distance(SensorWithEvent2.e, ev.location);
                double distBegOfS2 = MyMath.Distances.distance(SensorWithEvent2.b, ev.location);

                double min1 = Math.Min(distBegOfS1, distEndOfS1);
                double min2 = Math.Min(distBegOfS2, distEndOfS2);

                SensorWanted = (min1 < min2) ? SensorWithEvent2 : SensorWithEvent1;
               

            }
            else
            {
                if (LieOnEndOfS1 && !LieOnEndOfS2)
                    SensorWanted = SensorWithEvent2;

                if (LieOnEndOfS2 && !LieOnEndOfS1)
                    SensorWanted = SensorWithEvent1;

                if (LieOnEndOfS2 && LieOnEndOfS1)
                    return null;
            }

            if (SensorWanted == null)
                return null;

            double distBeg = MyMath.Distances.distance(SensorWanted.b, ev.location);
            double length = SensorWanted.getLength();
            double VecSize = distBeg / length;

            sn.rotateNetwork(oldAngle);
            MyPoint mp = new MyPoint(SensorWanted.b.x + VecSize * (SensorWanted.e.x - SensorWanted.b.x), SensorWanted.b.y + VecSize * (SensorWanted.e.y - SensorWanted.b.y));
            MyPointWithDist mpWD = new MyPointWithDist(mp,distBeg);

            mpWD.AddedAsEventLocation = true;
            mpWD.ForAddeqSPs.Add(new SPoint(null, null, null, ev.angle, ev.location));
            return new MPWDWithSensor(mpWD, SensorWanted);
        }

    }
}
