﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using WindowsFormsApplication1.SNetwork;

namespace WindowsFormsApplication1.SNetwork
{
    class MyList<T>
    {
        public static List<T> getListsTogether(List<T> l1, List<T> l2)
        {
            List<T> result = new List<T>(l1.Count() + l2.Count);
            result = l1.ToList();
            foreach (T t in l2)
            {
                if (!result.Contains(t))
                {
                    result.Add(t);
                }
            }
            return result;
        }

        public static bool SameLists(List<T> l1, List<T> l2)
        {
            if (l1.Count != l2.Count)
                return false;

            T F = l1.First();
            //zistime kolko prvkou ronvych prvemu sa nachadza v druhom zozname
            int count = l2.Count(i => i.Equals(F));
            //hladanu spravnu poziciu z moznych budeme inkrementovat, takze najskor to musi byt -1
            int pos = -1;
            
            //prejdeme vsetky mozne pozicie, kde zacina zoznam
            for (int j= 0; j<= count; j++)
            {
                pos = l2.IndexOf(F, pos + 1);
                if (pos == -1)
                    pos = 0;
                bool goodStart = true;
                bool goodStartReverse = true;
                //prejdeme prvky s j-tym posunutim, ktore sme vybrali
                for (int i = 0; i < l1.Count; i++)
                {
                    //ak sa nezhoduju prvky s tymto posunutim, tak nie je to dobre posunutie
                    if (!l1.ElementAt(i).Equals(l2.ElementAt((i + pos) % l2.Count)))
                        goodStart = false;
                    //ak sa nezhoduju prvky s tymto posunutim v opacnom smere, tak nie je to dobre posunutie
                    if (!l1.ElementAt(i).Equals(l2.ElementAt((-i + pos + l2.Count) % l2.Count)))
                        goodStartReverse = false;
                }

                //ak v jednom zo smerov s tymto posunutim sa vsetky prvky zhodovali vratime true
                if (goodStart || goodStartReverse)
                    return true;
            }
            return false;          
        }

        

        internal static bool ProperSubSet(List<T> SubList, List<T> List)
        {
            if (SubSet(SubList,List) && List.Count() > SubList.Count())
                return true;
            return false;
        }


        internal static bool SubSet(List<T> SubList, List<T> List)
        {
            foreach (T t in SubList)
            {
                if (!List.Contains(t))
                    return false;
            }
            return true;
        }

        internal static bool SubSet(List<SPoint> SubList, List<SPoint> List)
        {
            foreach (SPoint t in SubList)
            {
                //ak nie je v druhej mn a zaroven nie je specialny
                if (!List.Contains(t) && !t.speacial)
                    return false;
            }
            return true;
        }

        internal static bool SubCycle(List<T> SubList, List<T> List)
        {
            //ak zoznam ma tvorit podzoznam  musi mat mensi pocet prvkou
            if (SubList.Count >= List.Count)
                return false;

            T F = SubList.First();
            //zistime kolko prvkou ronvych prvemu sa nachadza v druhom zozname
            int count = List.Count(i => i.Equals(F));
            List<T> HelpList;
            List<T> HelpList1;
            List<T> HelpList2;
            int possition = -1;
            int MaxShift = Math.Max(SubList.Count() -1, ((List.Count()- SubList.Count()) /2) +1 );

            for (int j = 0; j <= count; j++)
            {
                possition = List.IndexOf(F, possition + 1);
                if (possition == -1)
                    possition = 0;

                for (int i = -MaxShift; i <= MaxShift; i++)
                {
                    int startPossision =(possition + i + List.Count()) % List.Count();
                    int stopPossision = startPossision + SubList.Count;

                    if (stopPossision < List.Count())
                    {
                        if (SameLists(SubList, List.GetRange(startPossision, SubList.Count)))
                            return true;
                    }
                    else
                    {
                        HelpList1 = List.GetRange(startPossision,List.Count() - (startPossision +1));
                        HelpList2 = List.GetRange(0,(stopPossision +1) % List.Count);
                        HelpList = MyList<T>.getListsTogether(HelpList1,HelpList2);
                        
                        if (SameLists(SubList, HelpList))
                            return true;
                    }
                }
            }
            return false;


        }

        internal static bool SameIndexes(List<SPoint> list1, List<SPoint> list2)
        {
            if (list1.Count() != list2.Count())
                return false;
            List<int> indexes1 = new List<int>(list1.Count());
            List<int> indexes2 = new List<int>(list2.Count());
            foreach (SPoint sp in list1)
            {
                indexes1.Add(sp.GraphIndex);
            }
            foreach (SPoint sp in list2)
            {
                indexes2.Add(sp.GraphIndex);
            }

            return MyList<int>.SameLists(indexes1, indexes2);

         }
    }
}
