﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using WindowsFormsApplication1.Graph;

namespace WindowsFormsApplication1.SNetwork
{
    class EqOfSAreasSearch
    {

        internal static void searchSAreasRelationships(List<Configuration> Configurations, List<Configuration> AdditionalConfigs)
        {
            if (Configurations.Count < 2)
                return;

            Configuration First, AfterFirst, Secound, Middle, BeforSecound;
            for (int i = 0; i < Configurations.Count; i++)
            {
                First = Configurations.ElementAt(i);
                Middle = AdditionalConfigs.ElementAt((i * 3) + 1);
                Secound = Configurations.ElementAt((i + 1) % Configurations.Count);
                searchClearAreas(First, Secound, Middle);
                searchEqAreas(First,Secound, Middle);
                AfterFirst = AdditionalConfigs.ElementAt((i * 3) );
                BeforSecound = AdditionalConfigs.ElementAt((i * 3+2));
                searchSpecialEqAreas(First, AfterFirst);
                connectSpecialAreasWithOriginalArea(AfterFirst);
                searchEqInsideStep(AfterFirst, Middle);
                searchEqInsideStep(Middle, BeforSecound);
                connectSpecialAreasWithOriginalAreaReverse(BeforSecound);
                searchEqAreas(Middle, Secound, Middle);
                searchSpecialEqAreasReverse(BeforSecound,Secound );
                backClear(Secound,BeforSecound, Middle, AfterFirst);
            }
        }

        private static void backClear(Configuration Secound, Configuration BeforSecound, Configuration Middle, Configuration AfterFirst)
        {
            foreach (SimpleArea sa in Secound.SAreas)
            {
                if (sa.clear)
                {
                    
                    foreach (SimpleArea EqSA in sa.EquivalentSAreas)
                    {
                        if (BeforSecound.SpecialSAreas.Contains(EqSA) || Middle.SAreas.Contains(EqSA))
                        {
                            EqSA.clear = true;

                            foreach (SimpleArea saAF in AfterFirst.SpecialSAreas)
                            {
                                if(MyList<SPoint>.SameIndexes(EqSA.V,saAF.V)){
                                    saAF.clear=true;
                                }
                            }
                        }
                    }                    
                }
            }
        }

        

        

        //ideme od after secound k secound configuracii.... 
        //pozorujeme ako spec. oblasti prisluchajuce jednej normalnej prevezmu jej vlastnosti
        private static void connectSpecialAreasWithOriginalArea(Configuration AfterConf)
        {


            foreach (SimpleArea SA in AfterConf.SAreas)
            {
                SA.SpecSubSA = new List<SimpleArea>();
                if (SA.inner)
                {
                    foreach (SimpleArea SpecSA in AfterConf.SpecialSAreas)
                    {
                        if (SpecSA.inner && MyList<SPoint>.SubSet(SpecSA.V, SA.V))
                        {
                            if (GraphOthers.hasCommonOriginalHalfEdge(SpecSA.V, SA.V))
                            {
                                SA.SpecSubSA.Add(SpecSA);
                            }
                        }
                    }
                }

                bool clear = true;
                int actualID = 0;
                bool sameActualId = true;
                if (SA.SpecSubSA.Count() != 0)
                    actualID = SA.SpecSubSA.First().actualIndex;

                foreach (SimpleArea subSA in SA.SpecSubSA)
                {
                    if (actualID != subSA.actualIndex)
                        sameActualId = false;
                    clear = clear && subSA.clear;
                }
                if (SA.SpecSubSA.Count() != 0)
                {
                    if (sameActualId)
                    {
                        SA.actualIndex = actualID;
                    }
                    SA.clear = clear;
                }
                if (SA.SpecSubSA.Count() == 1)
                    SA.actualIndex = SA.SpecSubSA.FirstOrDefault().actualIndex;
            }
        }

        //ideme od before secound k secound configuracii.... 
        //pozorujeme ako spec. oblasti prisluchajuce jednej normalnej prevezmu jej vlastnosti
        private static void connectSpecialAreasWithOriginalAreaReverse(Configuration BeforeConf)
        {
            foreach (SimpleArea SA in BeforeConf.SAreas)
            {
                SA.SpecSubSA = new List<SimpleArea>();
                if (SA.inner)
                {
                    foreach (SimpleArea SpecSA in BeforeConf.SpecialSAreas)
                    {
                        if (SpecSA.inner && MyList<SPoint>.SubSet(SpecSA.V, SA.V))
                        {
                            if (GraphOthers.hasCommonOriginalHalfEdge(SpecSA.V, SA.V))
                            {
                                SA.SpecSubSA.Add(SpecSA);
                            }
                        }
                    }
                }
                foreach (SimpleArea subSA in SA.SpecSubSA)
                {
                    subSA.clear = SA.clear;
                    subSA.actualIndex = SA.actualIndex;
                }
                
            }
        }

        private static void searchEqInsideStep(Configuration First, Configuration Secound)
        {
            foreach (SimpleArea sa1 in First.SAreas)
            {
                if (sa1.inner)
                {
                    foreach (SimpleArea sa2 in Secound.SAreas)
                    {
                        if (sa2.inner && MyList<SPoint>.SameIndexes(sa2.V, sa1.V))
                        {
                            sa2.actualIndex = sa1.actualIndex;
                            sa2.clear = sa1.clear;
                        }
                    }
                }
            }
        }

        private static void clearMiddleAreas(Configuration Middle, Configuration AfterFirst)
        {

            foreach (SimpleArea saMiddle in Middle.SAreas)
            {
                if (saMiddle.inner)
                {
                    foreach (SimpleArea sa in AfterFirst.SAreas)
                    {
                        if (sa.inner && MyList<SPoint>.SameIndexes(sa.V, saMiddle.V))
                        {
                            saMiddle.actualIndex = sa.actualIndex;

                            saMiddle.clear = sa.clear;
                        }
                    }
                }
            }
        }

        private static void searchSpecialEqAreasReverse( Configuration addconf, Configuration conf)
        {
            if (addconf.SpecialGraph == null || addconf.SpecialSAreas == null)
                return;

            foreach (SimpleArea sa1 in addconf.SpecialSAreas)
            {
                foreach (SimpleArea sa2 in conf.SAreas)
                {
                    if (AreEquals(sa1, sa2))
                    {
                        sa1.addEqSArea(sa2);
                        sa2.addEqSArea(sa1);
                        if (sa1.Angle < sa2.Angle)
                        {
                            sa2.actualIndex = sa1.actualIndex;
                            if (sa1.clear)
                                sa2.clear = true;
                        }
                    }
                }
            }
        }

        private static void searchSpecialEqAreas(Configuration conf, Configuration addconf)
        {
            if (addconf.SpecialGraph == null || addconf.SpecialSAreas == null)
                return;
            foreach (SimpleArea sa1 in conf.SAreas)
            {
                foreach (SimpleArea sa2 in addconf.SpecialSAreas)
                {
                    if (AreEquals(sa1, sa2))
                    {
                            sa1.addEqSArea(sa2);
                            sa2.addEqSArea(sa1);
                            if (sa1.Angle < sa2.Angle)
                            {
                                sa2.actualIndex = sa1.actualIndex;
                                if (sa1.clear)
                                    sa2.clear = true;
                            }
                    }
                }
            }
        }

        private static void searchClearAreas(Configuration conf1, Configuration conf2, Configuration middle)
        {
            if (conf1.EmptySAreas != null && conf1.EmptySAreas.Count > 0)
            {
                foreach (SimpleArea sa1 in conf2.SAreas)
                {
                    foreach (SimpleArea empty in conf1.EmptySAreas)
                    {
                        if (AreEquals(empty,sa1))
                        {
                            if (ExistMiddleEqArea(empty,sa1, middle))
                            {
                                sa1.clear = true;
                            }
                        }
                        if (sa1.clear)
                            break;
                    }
                }
            }
        }

        public static void searchEqAreas(Configuration conf1, Configuration conf2, Configuration middle)
        {
            foreach (SimpleArea sa1 in conf1.SAreas)
            {
                foreach(SimpleArea sa2 in conf2.SAreas){
                    
                    if (sa1.inner==sa2.inner &&  AreEquals(sa1,sa2))  
                    {
                        if (ExistMiddleEqArea(sa1, sa2, middle))
                        {
                            sa1.addEqSArea(sa2);
                            sa2.addEqSArea(sa1);
                            if (sa1.Angle < sa2.Angle)
                            {
                                sa2.actualIndex = sa1.actualIndex;
                                if (sa1.clear)
                                    sa2.clear = true;
                            }
                        }
                    }
                }              
            }
        }

        private static bool ExistMiddleEqArea(SimpleArea sa1, SimpleArea sa2, Configuration middle)
        {
            bool sa1Equals = false;
            bool sa2Equals = false;
           
            foreach (SimpleArea middleArea in middle.SAreas)
            {
                sa1Equals = AreEquals(sa1,middleArea);
    
                if (sa1Equals)
                    sa2Equals = AreEquals(sa2, middleArea);
                
                if (sa1Equals && sa2Equals)
                    return true;
            }

            return false;
        }

        public static bool AreEquals(SimpleArea sa1, SimpleArea sa2)
        {

            bool oneDirectionOfEq = SubSetInEq(sa1.VCleared, sa2.V);
            bool secoundDirectionOfEq = SubSetInEq(sa2.VCleared, sa1.V);

            if (oneDirectionOfEq && secoundDirectionOfEq)
            {
                return true;
            }
            return false;
        }

        /// <summary>
        /// overi ci ku kazdemu prvku prvej mnoziny ex. eq. prvok z druhej mnoziny
        /// </summary>
        /// <returns></returns>
        public static bool SubSetInEq(List<SPoint> list1, List<SPoint> list2)
        {
            bool hasEqSp =false;
            //prejdeme vsetky prvky prvej mnoziny vyzn. bodov
            foreach (SPoint sp in list1)
            {
                hasEqSp = false;
                //prejdeme ekvivalentne sp k sp
                foreach (SPoint spEq in sp.getAllEqSPs())
                {
                    //ak aspon jeden z jeho ekv. je v druhej mnozine
                    if (list2.Contains(spEq))
                    {
                        //oznacime, ze sme k prvku nasli eq. z druhej mn.
                        hasEqSp = true;
                        break;
                    }
                }
                //ak sme nenasli jemu ekv. este skusime,ci v druhej mn. nie je on sam...
                if (!hasEqSp && list2.Contains(sp))
                    hasEqSp = true;
                //ak sme nenasli ziadny eq. vyzn. bod, co by bol v druehj mn.

                //NOVE 
                if (!hasEqSp && !sp.AddedAsEventLocation)
                {
                    //vratime false
                    return false;
                }
            }
            //presli sme vs. prvky prvej mnoziny a kazdy mal eq. prvok v druhej, vratime true
            return true;
        }


    }


}
