﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using WindowsFormsApplication1.Events;

namespace WindowsFormsApplication1.SNetwork
{
    class EventSearch
    {

        static double anglest = 0;

        public static List<Event> getEvents(Step step1, Step step2, int jumpsRemains)
        {
            List<Event> firstHalf = new List<Event>(20);
            List<Event> secoundHalf = new List<Event>(20);
            

            List<Event> foundEventsBetweenTwoSteps = step1.getEvents(step2);
            if (foundEventsBetweenTwoSteps != null)
            {
                if (foundEventsBetweenTwoSteps.Count > 0)
                {
                    if (jumpsRemains > 0)
                    {

                        double midAngle = (step1.angle + step2.angle) / 2;
                        Program.cloud.sn.rotateNetworkAndSearchInters(midAngle);
                        Step middleStep = Step.makeStep(midAngle);
                        firstHalf = getEvents(step1, middleStep, jumpsRemains - 1);
                        secoundHalf = getEvents(middleStep, step2, jumpsRemains - 1);
                        if (firstHalf != null && secoundHalf != null)
                            return Event.getListsTogether(firstHalf, secoundHalf); 
                        if (firstHalf != null)
                            return firstHalf;
                        if (secoundHalf != null)
                            return secoundHalf;
                        return null;
                    }
                    else
                    {
                        return foundEventsBetweenTwoSteps;
                    }
                }
                else
                {
                    return null;
                }
            }
            else
            {
                return null;
            }
        }
        
        public static List<Event> getEvents(SNetwork sn1, int AngleStep, int jumps)
        {
            anglest = AngleStep;
            List<Event> allEvents = new List<Event>();
            List<Event> foundEvents;            
            SNetwork sn = Program.cloud.sn;
            sn.findOverlaps();
           
            for (int i=0 ;  i*AngleStep < 360+AngleStep ; i++){


                int angle1 = i * AngleStep;
                int angle2 = (i + 1) * AngleStep;

                Program.cloud.WriteToLog( angle1.ToString() + "; " + angle2.ToString());

                sn.rotateNetworkAndSearchInters(angle1);
                Step step1 = Step.makeStep(angle1);

                sn.rotateNetworkAndSearchInters(angle2);
                Step step2 = Step.makeStep(angle2);

                foundEvents = getEvents(step1, step2, jumps);
                if (foundEvents!=null)
                    foreach (Event ev in foundEvents)
                    {
                        if (allEvents.Contains(ev))
                        {
                            //   throw new Exception("Nemoze sa stat, ze najdeme rovnake eventy");
                        }
                        else
                        {
                            allEvents.Add(ev);
                        }
                    }
                Program.cloud.removeLastRow();
            }

            return allEvents;
        }


        internal static List<Event> getEventsToAdd(Configuration First, Configuration Secound, List<Event> AllEvents)
        {
            List<Event> result = new List<Event>(10);
            List<Event> EvInFirst = getEventsOfAngle(First.angle % 360 , AllEvents);
            List<Event> EvInSecound = getEventsOfAngle(Secound.angle % 360, AllEvents);

            foreach (Event ev in EvInFirst)
            {
                if ((ev.type == Event.SEPARATION && ev.Acters.Count() == 2) || ev.type == Event.OVERLAP)
                {
                    result.Add(ev);
                }
            }

            foreach (Event ev in EvInSecound)
            {
                if ((ev.type == Event.MEET && ev.Acters.Count() == 2) || ev.type == Event.OVERLAP)
                {
                    result.Add(ev);
                }
            }

            return result;

        }

        public static List<Event> getEventsOfAngle(double e, List<Event> allEvents)
        {
            List<Event> result = new List<Event>(10);
            if (allEvents != null)
            {
                foreach (Event ev in allEvents)
                {
                    if (ev.angle == e)
                    {
                        result.Add(ev);
                    }
                }
            }
            return result;
        }
    }
}
