﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using WindowsFormsApplication1.Events;
using WindowsFormsApplication1.MyMath;

namespace WindowsFormsApplication1.SNetwork
{
    class OverlapsSearch
    {
        public static void searchOverlapsOld(SNetwork sn)
        {
            Overlap[] ovl;
           
            sn.OverlapsClear();
             //prejdeme vsetky dvojice senzorov a podla ich typov pocitame prekrytia
            List<PairOfActers> visited = new List<PairOfActers>((sn.Sensors.Count * sn.Sensors.Count) / 2);
            foreach (Sensor s1 in sn.Sensors)
            {
                foreach (Sensor s2 in sn.Sensors)
                {
                    if (!s2.Equals(s1))
                    {
                        ovl = OverlapMath.getOverlap(s1, s2);
                        if (!visited.Contains(new PairOfActers(s1, s2)))
                        {
                            visited.Add(new PairOfActers(s1, s2));
                            //ak sme nasli prekrytie
                            if (ovl != null)
                            {
                                if (ovl.Count() > 0 && ovl[0] != null)
                                {
                                    s1.addOverlap(ovl[0]);
                                    s2.addOverlap(ovl[0]);
                                    sn.addOverlap(ovl[0]);
                                }
                                if (ovl.Count() > 1)
                                {
                                    s1.addOverlap(ovl[1]);
                                    s2.addOverlap(ovl[1]);
                                    sn.addOverlap(ovl[1]);
                                }
                            }
                        }
                    }
                }
            }
        }

        public static void searchOverlaps(SNetwork sn)
        {
            Overlap[] ovl;
            List<Sensor> closeSensors;
            List<Sensor>[,] sensorsInMash = Program.cloud.sn.SensorsInMash;
            if (sensorsInMash == null)
            {
                searchOverlapsOld(sn);
                return;
            }

            sn.OverlapsClear();
            //prejdeme vsetky dvojice senzorov a podla ich typov pocitame prekrytia
            List<PairOfActers> visited = new List<PairOfActers>((sn.Sensors.Count * sn.Sensors.Count) / 2);
            for (int i = 0; i < sensorsInMash.GetLength(0); i++)
            {
                for (int j = 0; j < sensorsInMash.GetLength(1); j++)
                {
                    foreach (Sensor s1 in sensorsInMash[i, j])
                    {
                        closeSensors = Program.cloud.sn.getCloseSensors(i, j);

                        foreach (Sensor s2 in closeSensors)
                        {
                            if (!s2.Equals(s1))
                            {
                                ovl = OverlapMath.getOverlap(s1, s2);
                                if (!visited.Contains(new PairOfActers(s1, s2)))
                                {
                                    visited.Add(new PairOfActers(s1, s2));
                                    //ak sme nasli prekrytie
                                    if (ovl != null)
                                    {
                                        if (ovl.Count() > 0 && ovl[0] != null)
                                        {
                                            s1.addOverlap(ovl[0]);
                                            s2.addOverlap(ovl[0]);
                                            sn.addOverlap(ovl[0]);
                                        }
                                        if (ovl.Count() > 1)
                                        {
                                            s1.addOverlap(ovl[1]);
                                            s2.addOverlap(ovl[1]);
                                            sn.addOverlap(ovl[1]);
                                        }

                                    }
                                }
                            }
                        }
                    }
                }
            }
        }
    }
}
