﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;
using System.Xml;
using WindowsFormsApplication1.SNetwork;
using System.Windows.Forms;
using WindowsFormsApplication1.Main;

namespace WindowsFormsApplication1.XMLwork
{
    class XMLRead
    {
        public static SNetwork.SNetwork getSNetworkFromFile(String filename)
        {
            SNetwork.SNetwork sn = new SNetwork.SNetwork();
            Sensor.maxid = 0;
            addSensorsFromFile(sn, filename);
            return sn;
        }

        public static bool addSensorsFromFile(SNetwork.SNetwork sn, String filename)
        {
            sn.changed = true;
            String path;
            if (filename.CompareTo("") ==0)
                path = Path.Combine(Environment.CurrentDirectory, @"..\..\SensorNetwork\SNetwork.xml");
            else
                path = filename;

            try
            {
                string text = System.IO.File.ReadAllText(path);

                XmlDocument doc = new XmlDocument();
                doc.Load(path);
                Sensor TempSensor;
                XmlNodeList nodeListB = doc.SelectNodes("//BSensor");
                foreach (XmlNode node in nodeListB)
                {
                    double x1 = double.Parse(node.Attributes["X1"].Value);
                    double x2 = double.Parse(node.Attributes["X2"].Value);
                    double y1 = double.Parse(node.Attributes["Y1"].Value);
                    double y2 = double.Parse(node.Attributes["Y2"].Value);

                    TempSensor = new BSensor(x1, y1, x2, y2);
                    sn.AddSensor(TempSensor);
                }

                XmlNodeList nodeListR = doc.SelectNodes("//RSensor");
                foreach (XmlNode node in nodeListR)
                { 
                    double x1 = double.Parse(node.Attributes["X1"].Value);
                    double x2 = double.Parse(node.Attributes["X2"].Value);
                    double y1 = double.Parse(node.Attributes["Y1"].Value);
                    double y2 = double.Parse(node.Attributes["Y2"].Value);
                    bool rot = ((node.Attributes["O"].Value) == "1");

                    TempSensor = new RSensor(x1, y1, x2, y2, rot);
                    sn.AddSensor(TempSensor);
                }

                XmlNodeList nodeListRaster = doc.SelectNodes("//Raster");
                foreach (XmlNode node in nodeListRaster)
                {
                    Parameters.scaleFactor = int.Parse(node.Attributes["raster"].Value);
                }

                XmlNodeList nodeListHeight = doc.SelectNodes("//RowHeight");
                foreach (XmlNode node in nodeListHeight)
                {
                    Parameters.RowHeight = int.Parse(node.Attributes["height"].Value);
                }

                XmlNodeList nodeListPD = doc.SelectNodes("//PointDeviation");
                foreach (XmlNode node in nodeListPD)
                {
                    Parameters.pointDeviation = double.Parse(node.Attributes["value"].Value);
                }

                XmlNodeList nodeListAD = doc.SelectNodes("//AngleDeviation");
                foreach (XmlNode node in nodeListAD)
                {
                    Parameters.angleDeviation = double.Parse(node.Attributes["value"].Value);
                }

                XmlNodeList nodeListEC = doc.SelectNodes("//EpsilonConf");
                foreach (XmlNode node in nodeListEC)
                {
                    Parameters.angleEpsilonInConf = double.Parse(node.Attributes["value"].Value);
                }

                XmlNodeList nodeListPS = doc.SelectNodes("//Pseudostep");
                foreach (XmlNode node in nodeListPS)
                {
                    Parameters.angleOfPseudoStep = int.Parse(node.Attributes["value"].Value);
                }

                XmlNodeList nodeListIT = doc.SelectNodes("//Iterations");
                foreach (XmlNode node in nodeListIT)
                {
                    Parameters.iterations = int.Parse(node.Attributes["value"].Value);
                }

                XmlNodeList nodeListRD = doc.SelectNodes("//Rounds");
                foreach (XmlNode node in nodeListRD)
                {
                    Parameters.countOfRot = int.Parse(node.Attributes["value"].Value);
                }

                Program.cloud.resetOptionsValues();

            }
            catch (FileNotFoundException ex)
            {
                Console.WriteLine(ex);
                return false;
            }
            Program.cloud.WriteToLog("uspesne nacitana siet zo suboru xml:" + path.ToString());

            MainClass.ClearAll();
            sn.resetActualNetwork();
            return true;
        }



       
    }
}
