﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Xml;
using WindowsFormsApplication1.SNetwork;
using WindowsFormsApplication1.Main;
using WindowsFormsApplication1.Events;

namespace WindowsFormsApplication1.XMLwork
{
    class XMLWrite
    {
        public static bool saveWithEvent = false;

        public static bool saveNetoworkInFile(SNetwork.SNetwork sn)
        {
            return saveNetoworkInFile(sn, Program.cloud.actualPathToSN);
        }

        internal static bool saveNetoworkInFile(SNetwork.SNetwork sn, string p)
        {
            XmlDocument xmldoc = new XmlDocument();
            XmlNode xmlRoot, xmlNode;
            xmlRoot = xmldoc.CreateElement("SNetwork");
            xmldoc.AppendChild(xmlRoot);

            XmlAttribute x1;
            XmlAttribute y1;
            XmlAttribute x2;
            XmlAttribute y2;
            XmlAttribute o;
            XmlAttribute a;

            foreach (Sensor s in sn.Sensors)
            {
                x1 = xmldoc.CreateAttribute("X1");
                y1 = xmldoc.CreateAttribute("Y1");
                x2 = xmldoc.CreateAttribute("X2");
                y2 = xmldoc.CreateAttribute("Y2");
                o = xmldoc.CreateAttribute("O");
                a = xmldoc.CreateAttribute("A");

                //we supposed it isn't any other option, just beam or rot sensor
                xmlNode = (s is BSensor) ? xmldoc.CreateElement("BSensor") : xmldoc.CreateElement("RSensor");

                x1.Value = s.bTriangleNetPoint.x.ToString();
                y1.Value = s.bTriangleNetPoint.y.ToString();
                x2.Value = s.eTriangleNetPoint.x.ToString();
                y2.Value = s.eTriangleNetPoint.y.ToString();
                xmlNode.Attributes.Append(y2);
                xmlNode.Attributes.Append(x2);
                xmlNode.Attributes.Append(y1);
                xmlNode.Attributes.Append(x1);

                if (s is RSensor)
                {
                    x1.Value = ((RSensor)s).bTriangleNetPoint.x.ToString();
                    y1.Value = ((RSensor)s).bTriangleNetPoint.y.ToString();
                    x2.Value = ((RSensor)s).eTriangleNetPoint.x.ToString();
                    y2.Value = ((RSensor)s).eTriangleNetPoint.y.ToString();

                    o.Value = ((RSensor)s).RotDirection ? "1" : "0";
                    xmlNode.Attributes.Append(o);
                    if (((RSensor)s).DetectAngle > 0)
                    {
                        a.Value = ((RSensor)s).DetectAngle.ToString();
                        xmlNode.Attributes.Append(a);
                    }
                }
                xmlRoot.AppendChild(xmlNode);
            }

            //pridame raster
            a = xmldoc.CreateAttribute("raster");
            a.Value = Parameters.scaleFactor.ToString();
            xmlNode = xmldoc.CreateElement("Raster");
            xmlNode.Attributes.Append(a);
            xmlRoot.AppendChild(xmlNode);

            a = xmldoc.CreateAttribute("height");
            a.Value = Parameters.RowHeight.ToString();
            xmlNode = xmldoc.CreateElement("RowHeight");
            xmlNode.Attributes.Append(a);
            xmlRoot.AppendChild(xmlNode);

            a = xmldoc.CreateAttribute("value");
            a.Value = Parameters.pointDeviation.ToString();
            xmlNode = xmldoc.CreateElement("PointDeviation");
            xmlNode.Attributes.Append(a);
            xmlRoot.AppendChild(xmlNode);

            a = xmldoc.CreateAttribute("value");
            a.Value = Parameters.angleDeviation.ToString();
            xmlNode = xmldoc.CreateElement("AngleDeviation");
            xmlNode.Attributes.Append(a);
            xmlRoot.AppendChild(xmlNode);

            a = xmldoc.CreateAttribute("value");
            a.Value = Parameters.angleEpsilonInConf.ToString();
            xmlNode = xmldoc.CreateElement("EpsilonConf");
            xmlNode.Attributes.Append(a);
            xmlRoot.AppendChild(xmlNode);

            a = xmldoc.CreateAttribute("value");
            a.Value = Parameters.angleOfPseudoStep.ToString();
            xmlNode = xmldoc.CreateElement("Pseudostep");
            xmlNode.Attributes.Append(a);
            xmlRoot.AppendChild(xmlNode);

            a = xmldoc.CreateAttribute("value");
            a.Value = Parameters.iterations.ToString();
            xmlNode = xmldoc.CreateElement("Iterations");
            xmlNode.Attributes.Append(a);
            xmlRoot.AppendChild(xmlNode);

            a = xmldoc.CreateAttribute("value");
            a.Value = Parameters.countOfRot.ToString();
            xmlNode = xmldoc.CreateElement("Rounds");
            xmlNode.Attributes.Append(a);
            xmlRoot.AppendChild(xmlNode);

            String path = p; //Application.StartupPath + "\\SNetworkSaved.xml";
            //String path = Path.Combine(Environment.CurrentDirectory, @"..\..\SensorNetwork\mojedata2.xml");
            xmldoc.Save(path);
            Program.cloud.WriteToLog("uspesne zapisane do suboru:" + path.ToString());
            return true;
        }
    }
}
